disp('Load/create diffusion coefficients')

import diff_coeff.calc_DLL
import diff_coeff.calc_derivatives_LVK_LPA_3D
import diff_coeff.FixDiffCoeff_4D
import diff_coeff.convert_diff_coeff

import read_write.load_plt

import VERB4D_scripts.*

%% Local diffusion coefficients        

% chorus FA
[L_chorus, en_chorus, al_chorus, Daa_chorus_day] = load_plt(['DiffCoeff/Daa_chorus_day_FA.plt'], 'make3D');
[L_chorus, en_chorus, al_chorus, Daa_chorus_night] = load_plt(['DiffCoeff/Daa_chorus_night_FA.plt'], 'make3D');

% MLT-average chorus
Chorus_MLT = 0.25;

Daa_chorus_day.arr = Daa_chorus_day.arr .* Chorus_MLT;
Daa_chorus_night.arr = Daa_chorus_night.arr .* Chorus_MLT;

Daa_Q_chorus_day_3D = Daa_chorus_day.arr;
Dpp_Q_chorus_day_3D = Daa_chorus_day.arr*0;
Dpa_Q_chorus_day_3D = Daa_chorus_day.arr*0;

Daa_Q_chorus_night_3D = Daa_chorus_night.arr;
Dpp_Q_chorus_night_3D = Daa_chorus_night.arr*0;
Dpa_Q_chorus_night_3D = Daa_chorus_night.arr*0;

%% 3.2 Interpolate Diffusion Coefficients onto (L_Q, E_Q, A_Q) grid
%disp('Interpolating chorus day...          ');
%[Dpp_Q_chorus_day_3D, Dpa_Q_chorus_day_3D, Daa_Q_chorus_day_3D] = interpolate_extrapolate_3D(L_chorus.arr, pc_chorus.arr, al_chorus.arr, Dpp_chorus_day.arr, Dpa_chorus_day.arr, Daa_chorus_day.arr, permute(L.arr(1,:,:,:), [2,3,4,1]), permute(pc.arr(1,:,:,:), [2,3,4,1]), permute(al.arr(1,:,:,:), [2,3,4,1]));
%disp('Interpolating chorus night...          ');
%[Dpp_Q_chorus_night_3D, Dpa_Q_chorus_night_3D, Daa_Q_chorus_night_3D] = interpolate_extrapolate_3D(L_chorus.arr, pc_chorus.arr, al_chorus.arr, Dpp_chorus_night.arr, Dpa_chorus_night.arr, Daa_chorus_night.arr, permute(L.arr(1,:,:,:), [2,3,4,1]), permute(pc.arr(1,:,:,:), [2,3,4,1]), permute(al.arr(1,:,:,:), [2,3,4,1]));

Daa_chorus_day_4D.arr = zeros(size(P.arr));
Daa_chorus_night_4D.arr = zeros(size(P.arr));
Daa_chorus_day_4D.arr(1, 1, 2, :) = squeeze(Daa_Q_chorus_day_3D);
Daa_chorus_night_4D.arr(1, 1, 2, :) = squeeze(Daa_Q_chorus_night_3D);

if (~use_matlab)
save_plt_4d([DiffCoeff_output_folder, 'Daa_chorus_day.plt'], P, L, pc, al, Daa_chorus_day_4D);
save_plt_4d([DiffCoeff_output_folder, 'Daa_chorus_night.plt'], P, L, pc, al, Daa_chorus_night_4D);
else
save([DiffCoeff_output_folder, 'Daa_chorus_day'], 'P', 'L', 'pc', 'al', 'Daa_chorus_day_4D');
save([DiffCoeff_output_folder, 'Daa_chorus_night'], 'P', 'L', 'pc', 'al', 'Daa_chorus_night_4D');    
end
