clearvars -except use_matlab
%cd('e:\Codes_and_calculations\VERB_SVN_Sources\VERB_4D\Examples\1.0 1D_Alpha_Example\');
addpath('../../VERB4D_Library')

import read_write.load_PSD
import read_write.load_PSD_mat


VERB4D_output_folder = './VERB4D_output/';
VERB4D_input_folder = './VERB4D_input/';

%PSD = load_PSD(folder);

if (~use_matlab)
[P, R, V, K, L, en, al, mu] = load_4d([VERB4D_input_folder, 'Lstar.plt']);
else
load([VERB4D_input_folder, 'Lstar.mat']);
en.size = pc.size;
en.arr = Kfunc(pc.arr);
end
%% Plot energy-alpha
if(~use_matlab)
PSD = load_PSD(VERB4D_output_folder, 'step', 1, 'max', 999);
else
PSD = load_PSD_mat(VERB4D_output_folder, 'step', 1, 'max', 999);
end

PSD.arr = PSD.arr * 3e7;

target_en = 1.0;
[tmp, en_idx] = min(abs(en.arr(1,1,:,end) - target_en));
PSD_1d = squeeze(PSD.arr(:,1,1,en_idx,:));
al_1d = squeeze(al.arr(1,1,en_idx,:))*180/pi;

if (~use_matlab)
[P, R, pc, al, Daa_chorus_day] = load_4d('VERB4D_input/DiffCoeff_Q/Daa_chorus_day.plt');
[P, R, pc, al, Daa_chorus_night] = load_4d('VERB4D_input/DiffCoeff_Q/Daa_chorus_night.plt');
else
load('VERB4D_input/DiffCoeff_Q/Daa_chorus_day.mat');
load('VERB4D_input/DiffCoeff_Q/Daa_chorus_night.mat');
Daa_chorus_day = Daa_chorus_day_4D;
Daa_chorus_night = Daa_chorus_night_4D;
end

MLT_ave = 0.25;
Daa_chorus_day_1d = squeeze(Daa_chorus_day.arr(1,1,en_idx,:)) / MLT_ave;
Daa_chorus_night_1d = squeeze(Daa_chorus_night.arr(1,1,en_idx,:)) / MLT_ave;

al_chorus_1d = squeeze(al.arr(1,1,en_idx,:))*180/pi;

figure('Units', 'inches', 'Position', [1 1 8 6],...
    'DefaultAxesFontName', 'times new roman', 'DefaultAxesFontWeight', 'bold', 'DefaultAxesFontSize', 9,...
    'PaperOrientation', 'portrait', 'PaperPositionMode', 'auto', 'DefaultTextFontWeight', 'bold');%, 'PaperPosition', [1 1 3.8 9]);%

subplot(3,3,1);
hold on 
plot(al_chorus_1d, Daa_chorus_day_1d, 'k', 'LineWidth', 2);
plot(al_chorus_1d, Daa_chorus_night_1d, 'b', 'LineWidth', 2);
set(gca, 'yscale', 'log', 'xlim', [0 90], 'ylim', [1e-3 5e1]);

subplot(3,3,4);

% colormap
cmap = jet(size(PSD_1d,1));
% black for first color
cmap(1, :) = [0, 0, 0];

% using colormap

set(gca, 'ColorOrder', cmap, 'NextPlot', 'replacechildren', 'Box', 'on');
plot(al_1d, PSD_1d, 'LineWidth', 1);
set(gca, 'yscale', 'log', 'xlim', [0 90], 'ylim', [1e-3 1e1]);


subplot(3,3,7);

it = (length(PSD.time)-1);
dt = PSD.time(it+1) - PSD.time(it);
decay.arr = (PSD_1d(it+1, :) + PSD_1d(it, :)).*dt./(PSD_1d(it, :) - PSD_1d(it+1, :))./2;

% using colormap
set(gca, 'yscale', 'linear','ColorOrder', cmap, 'NextPlot', 'replacechildren', 'Box', 'on');
plot(al_1d, decay.arr,'k',  'LineWidth', 2);
set(gca, 'xlim', [0 90], 'ylim', [0 40]);

