%% Download or create satellite data

import sat_data.omniwebdata

disp('Creating Kp data');

load('VERB4D_prep')

try
    if use_cache
        load([VERB4D_prep_folder, 'sat_data.mat'])
        if (Kp.time(1) > time(1) || Kp.time(end) < time(end))
            error(' ');
        end
    else
        error(' '); %generate empty error
    end
catch
   %% 
    
    if (false)
        %%
        % SW_data = [060000,   21.06,    401.60,  0.04,   68.89,     16.00,  61,  02,       -3.05,  00,  00]; % datenum('2001-01-00') + 111 + 1.69
        %          IBTIME    N_SW    V_SW    Na/Np   PCP        Dst ABI  Kp       IMF_BZ_GSM G2  G3 IMF_BY_GSM
        [OMNI_time, Kp10, Dst, IMF_By_GEO, IMF_Bz_GEO, IMF_By_GSM, IMF_Bz_GSM, IMF_Dp, N_SW, V_SW, PCP] = omniwebdata(start_date, start_date+total_time, 38, 40, 13, 14, 15, 16, 28, 23, 24, 51);    
        %[OMNI_time, Kp_data, IMF_Bz, IMF_Dp] = omniwebdata(datenum(datestr(start_date, 'yyyymmdd'), 'yyyymmdd'), datenum(datestr(start_date+total_time, 'yyyymmdd'), 'yyyymmdd'), 38, 14, 28);

        IMF_Bz = IMF_Bz_GSM;

        IMF_Bz.arr(IMF_Bz.arr>999) = NaN;
        IMF_Dp.arr(IMF_Dp.arr>99) = NaN;

        %AllKp10.arr = unique(Kp10.arr);
        AllKp10.arr = unique(round(Kp10.arr/10)*10);

        save([VERB4D_prep_folder, 'sat_data'], 'Kp10', 'AllKp10', 'IMF_Bz', 'IMF_Dp', 'Dst', 'IMF_By_GEO', 'IMF_Bz_GEO', 'IMF_By_GSM', 'IMF_Bz_GSM', 'N_SW', 'V_SW', 'PCP');

    else
        
        %%
        Kp_data = [2, 6, 6, 2, 2]';
        Kp_time = (start_date + [0, 1, 2, 5, 999])';
        Kp10.arr = interp1(Kp_time', Kp_data'*10, time);
        Kp10.time = time;
        Kp10.name = 'Kp10';
        
        %Kp.time = time(1):3/24:time(end); % every 3 hours
        %Kp.arr = round(round(interp1(Kp_time, Kp_data, Kp.time)*3)/3*10)/10;
       
        AllKp10.arr = [0, 0.3, 0.6, 1, 1.3, 1.6, 2, 2.3, 2.6, 3, 3.3, 3.6, 4, 4.3, 4.6, 5, 5.3, 5.6, 6]'*10;

        save([VERB4D_prep_folder, 'sat_data'], 'Kp10', 'AllKp10');          
    end
    
    
end



if (false)
    %%
    import plotting.subplot1
    figure
    subplot1(4, 1);

    subplot1(1)
    %subplot(3,1,1)
    plot(Kp10.time, Kp10.arr/10, '*-')
    xlim([Kp10.time(1) Kp10.time(end)])
    ylabel('Kp')
    %datetick('x', 'keeplimits')

    subplot1(2)
    %subplot(3,1,1)
    plot(Dst.time, Dst.arr, '*-')
    xlim([Dst.time(1) Dst.time(end)])
    ylabel('Dst')
    %datetick('x', 'keeplimits')
    
    subplot1(3)
    %subplot(3,1,2)
    plot(IMF_Bz.time, IMF_Bz.arr, '*-')
    xlim([Kp10.time(1) Kp10.time(end)])
    ylabel('IMF Bz')
    %datetick('x', 'keeplimits')
    
    subplot1(4)
    %subplot(3,1,3)
    plot(IMF_Dp.time, IMF_Dp.arr, '*-')
    xlim([Kp10.time(1) Kp10.time(end)])
    ylabel('IMF Dp')
    datetick('x', 'keeplimits')
end

