
clearvars -except use_matlab

addpath('../../VERB4D_Library')

import read_write.*
import plotting.*
import VERB4D_scripts.*

load('VERB4D_prep.mat')
load([VERB4D_prep_folder, 'sat_data.mat'])
load([VERB4D_prep_folder, 'grid.mat'])

Lpp_file = load([VERB4D_input_folder, 'Lpp.dat']); Rpp.time = Lpp_file(:,1); Rpp.arr = Lpp_file(:,2); Rpp.name = 'Plasmapause';
DLL_scale_file = load([VERB4D_input_folder, 'DLL_scale.dat']); DLL_scale.time = DLL_scale_file(:,1); DLL_scale.arr = DLL_scale_file(:,2); DLL_scale.name = 'DLL scale';

if (true)
    %% Plot PSD

    target_MLT = 0;    target_mu = 700;    target_K = 0.025;    c_min = -8.5;    c_max = -4.5;
    %target_MLT = 0;    target_mu = 100;    target_K = 0.025;    c_min = -4.5;    c_max = -1.5;
    %target_mu = 20;    target_K = 0.025;    c_min = -1.5;    c_max = -0.5;
    %target_mu = 1;    target_K = 0.025;    c_min = 1;    c_max = 2.5;
    
    if (use_matlab)
    PSD_interp = load_and_interpolate_PSD_mat(VERB4D_output_folder, mu, K, target_mu, target_K, 'method', 'nearest', 'step', 1, 'max', 99999, 'reload');
    else
    PSD_interp = load_and_interpolate_PSD(VERB4D_output_folder, mu, K, target_mu, target_K, 'method', 'nearest', 'step', 1, 'max', 99999, 'reload');
    end
    
    %PSD_interp.arr(PSD_interp.arr<=0) = 1e-21;
    
    [tmp, P_idx] = min(abs(mod(P.arr(:, 1, 1, 1)*12/pi-12,24) - target_MLT));           
    
    new_PSD.arr = squeeze(PSD_interp.arr(:, P_idx, :, :));
    new_PSD.time = PSD_interp.time;    
    
    figure_title = ['PSD at MLT = ' num2str(target_MLT), ', K = ', num2str(PSD_interp.Q2), ' G^{0.5} R_{E},  \mu = ', num2str(PSD_interp.Q1), ' MeV/G '];
    file_name = ['PSD_K=', num2str(PSD_interp.Q2), '_mu=', num2str(PSD_interp.Q1)];

    plotting.plot_f_L_time_4D(new_PSD, R, 'caxis', [c_min, c_max], 'figure_title', figure_title, 'Panel1', Rpp, 'Panel3', Kp10, 'Panel2', DLL_scale, 'plot_type', 'pcolor')

    set(gcf, 'name', pwd);
        
end

%%

