clearvars -except use_matlab

addpath('../../VERB4D_Library')

import read_write.load_PSD
import read_write.load_PSD_mat

load('VERB4D_prep')
load([VERB4D_prep_folder, 'grid.mat']);
load([VERB4D_prep_folder, 'LEA.mat']);

%% Plot energy-alpha
if (use_matlab)
PSD = load_PSD_mat(VERB4D_output_folder, 'step', 1, 'max', 999);
else
PSD = load_PSD(VERB4D_output_folder, 'step', 1, 'max', 999);
end

target_P = 6;
target_L = 4.5;
c_min = -16;
c_max = -8;
en_min = 1e-1;
en_max = 1e1;

[tmp, P_idx] = min(abs(mod(P.arr(:, 1, 1, 1)*12/pi-12,24) - target_P));
[tmp, L_idx] = min(abs(L.arr(P_idx, :, 1, 1) - target_L));

%Q1_slice = 1;
en_2d = squeeze(en.arr(P_idx, L_idx, :, :));
al_2d = squeeze(al.arr(P_idx, L_idx, :, :))*180/pi;

PSD_2d.arr = permute(PSD.arr(:, P_idx, L_idx,:,:), [1, 4, 5, 2, 3]);
PSD_2d.time = PSD.time;

figure_title = ['PSD, L=', num2str(unique(L.arr(P_idx, L_idx, :, :)))];

plotting.plot_f_energy_alpha_4D(PSD_2d, en_2d, al_2d, c_min, c_max, en_min, en_max, figure_title);

set(gcf, 'name', pwd);

%%

