%% Download or create satellite data

import sat_data.omniwebdata

disp('Creating Kp data');

load('VERB4D_prep') % read some parameters

try
    if use_cache
        load([VERB4D_prep_folder, 'sat_data.mat'])
        if (Kp10.time(1) > time(1) || Kp10.time(end) < time(end))
            error(' ');
        end
    else
        error(' '); %generate empty error
    end
catch
   %% 
    
    if (true)
        %%
        % Use OmniWeb to download required data
        [OMNI_time, Kp10, Dst, IMF_By_GEO, IMF_Bz_GEO, IMF_By_GSM, IMF_Bz_GSM, IMF_Dp, N_SW, V_SW, PCP] = omniwebdata(start_date, start_date+total_time, 38, 40, 13, 14, 15, 16, 28, 23, 24, 51);    

        IMF_Bz = IMF_Bz_GSM;

        IMF_Bz.arr(IMF_Bz.arr>999) = NaN;
        IMF_Dp.arr(IMF_Dp.arr>99) = NaN;

        AllKp10.arr = unique(Kp10.arr);

        % Use only rounded Kp, for compatison with 4D
        %AllKp10.arr = unique(round(Kp10.arr/10)*10);
        %' !!!!!!! Kp ROUNDED FOR COMPARISON !!!!!!!! '
        %Kp10.arr = round(Kp10.arr/10)*10;
        
    else
        
        % Typical storm Kp index
        Kp_data = [2, 6, 6, 2, 2]';
        Kp_time = (start_date + [0, 1, 2, 5, 999])';
        Kp10.arr = interp1(Kp_time', Kp_data'*10, time);
        Kp10.time = time;
        
        %Kp.time = time(1):3/24:time(end); % every 3 hours
        %Kp.arr = round(round(interp1(Kp_time, Kp_data, Kp.time)*3)/3*10)/10;

        IMF_Bz.arr = 0;
        IMF_Bz.time = Kp10.time(1);
        IMF_Dp.arr = 5;
        IMF_Dp.time = Kp10.time(1);
       
        AllKp10.arr = [0, 0.3, 0.6, 1, 1.3, 1.6, 2, 2.3, 2.6, 3, 3.3, 3.6, 4, 4.3, 4.6, 5, 5.3, 5.6, 6]'*10;
        
    end
    
    save([VERB4D_prep_folder, 'sat_data'], 'Kp10', 'AllKp10', 'IMF_Bz', 'IMF_Dp', 'Dst');
    
end


if (true)
    %%
    import plotting.subplot1
    figure
    subplot1(4, 1)

    subplot1(1)
    %subplot(3,1,1)
    plot(Kp10.time, Kp10.arr/10, '*-')
    xlim([Kp10.time(1) Kp10.time(end)])
    ylabel('Kp')
    %datetick('x', 'keeplimits')

    subplot1(2)
    %subplot(3,1,1)
    plot(Dst.time, Dst.arr, '*-')
    xlim([Dst.time(1) Dst.time(end)])
    ylabel('Dst')
    %datetick('x', 'keeplimits')
    
    subplot1(3)
    %subplot(3,1,2)
    plot(IMF_Bz.time, IMF_Bz.arr, '*-')
    xlim([Kp10.time(1) Kp10.time(end)])
    ylabel('IMF Bz')
    %datetick('x', 'keeplimits')
    
    subplot1(4)
    %subplot(3,1,3)
    plot(IMF_Dp.time, IMF_Dp.arr, '*-')
    xlim([Kp10.time(1) Kp10.time(end)])
    ylabel('IMF Dp')
    datetick('x', 'keeplimits')
end



