% Reproductin of Kim at all [xxxx] paper
% with two zone radiation belt structure

% Include VERB4D_Library into the path
addpath('../../VERB4D_Library');

clear all
disp('3D diffusion')

% Here we specify folders, where we save data
% VERB4D_input and VERB4D_output are expected by VERB4D_Solver and can not
% be changed. VERB4D_prep is a temporary folder for Matlab files
VERB4D_input_folder = 'VERB4D_input/'; % input folder for VERB4D_Solver
VERB4D_output_folder = 'VERB4D_output/'; % output folder for VERB4D_Solver
VERB4D_prep_folder = 'VERB4D_prep/'; % folder for temporary Matbal files
% Diffusion coefficient folders:
DiffCoeff_input_folder = '../../'; % Where to read diffusion coefficients
DiffCoeff_output_folder = 'VERB4D_input/DiffCoeff_Q/'; % Where to save

mkdir(VERB4D_input_folder);
mkdir(VERB4D_output_folder);
mkdir(VERB4D_prep_folder)
mkdir(DiffCoeff_output_folder);

%% Computational parametersparameters
total_time = 100; %days
time_step = 1/24/2; %days
output_time = 10/24/2; %days

time = [0:time_step:total_time];
Kp0 = 1; % Kp for initial PSD
DxxKp = 4; % Kp for which diffusion coefficients were calculated. Used for scaling.

use_matlab = true;


%system(['rm ', VERB4D_output_folder, '*']);
if (true) % This needs to be recalculated only if grid changes
    %% Delete previous results
    system(['rm ', VERB4D_input_folder, '*']);
    
    %% Create (P, R, V, K) grid with size(P) = 1 and calculate L, E, A on the new grid
    create_grid
        
    %% Calculate L*, energy, pitch-angle, and Jacobians
    create_LEA_J_Dip    

    %% Create initial PSD
    create_initial_PSD

    %% Create boundary conditions
    create_boundary_conditions

    %% Load/calculate diffusion coefficients
    create_diffusion_coefficients

    %% 3. Create losses (loss cone)
    create_sources_and_losses
end


%% 2.2 Create scaling of everything, here is pretty much all the setup is done
create_scaling

%% Parameters.ini
fid = fopen('parameters.ini', 'w');
fprintf(fid, ['time_total = ', num2str(total_time), '\n']); %
fprintf(fid, ['time_step = ', num2str(time_step), '\n']); %
fprintf(fid, ['time_output = ', num2str(output_time), '\n']); %
fprintf(fid, ['max_threads = 8 \n inversion_method = Lapack \n']); %
%fprintf(fid, ['max_threads = 8 \n inversion_method = ADI \n']); %
if (use_matlab)
    fprintf(fid, ['use_matlab = true \n']); % must be lower case "true" or "false"
else
    fprintf(fid, ['use_matlab = false \n']); % must be lower case "true" or "false"
end
fprintf(fid, ['include_boundary = true \n']); % must be lower case "true" or "false"
fclose(fid);


%% RUN
'RUN VERB4D'
tic; system('./VERB4D_Solver'); toc
%system('./bgr_run.sh VERB4D_Solver') % Run in the background
%system('tail -n 50 screen.log')

%% Plot
plot_results

