%% NOTE: Losses should be NEGATIVE! Othervise it's sources.

import plasma.Dip.alc_Dip
import plasma.calc_Coulomb

import plasma.Dip.taulc_Dip

if (true)
    disp('Sources and losses')
    Sources.arr = zeros(P.size, R.size, V.size, K.size);
    
    if (use_matlab)
    save([VERB4D_input_folder, 'Sources'], 'P', 'R', 'V', 'K', 'Sources');
    else
    save_plt_4d([VERB4D_input_folder, 'Sources.plt'], P, R, V, K, Sources);
    end
    
    % Losses
    Losses_lc.arr = zeros(P.size, R.size, V.size, K.size);
    % Add loss cone
    idx = (al.arr < alc_Dip(L.arr));
    Losses_lc.arr(idx) = -1./taulc_Dip(L.arr(idx), pc.arr(idx), al.arr(idx));
    
    if (use_matlab)
    save([VERB4D_input_folder, 'Losses_losscone'], 'P', 'R', 'V', 'K', 'Losses_lc');
    else
    save_plt_4d([VERB4D_input_folder, 'Losses_losscone.plt'], P, R, V, K, Losses_lc);
    end
    
    % EXTRA LOSSES
    Losses_par.arr = zeros(P.size, R.size, V.size, K.size);
    Losses_par.arr(:) = -1./(4./Kp0);
    % 10 days life time inside plasmasphere
    %Losses.arr(:) = Losses.arr(:) - 1./10;
    
    if (use_matlab)
    save([VERB4D_input_folder, 'Losses_parameterized'], 'P', 'R', 'V', 'K', 'Losses_par');
    else
    save_plt_4d([VERB4D_input_folder, 'Losses_parameterized.plt'], P, R, V, K, Losses_par);
    end
       
    
    % Coulomb scattering losses
    tau_c = calc_Coulomb(L.arr, en.arr);
    Losses_c.arr = -1./tau_c;
    
    if (use_matlab)
    save([VERB4D_input_folder, 'Losses_coulomb'], 'P', 'R', 'V', 'K', 'Losses_c');
    else
    save_plt_4d([VERB4D_input_folder, 'Losses_coulomb.plt'], P, R, V, K, Losses_c);
    end
     

    % Magnetopause losses
    try 
        Losses.arr(find(outside_idx)) = -1e21; 
          
        if (use_matlab)
        save([VERB4D_input_folder, 'Losses_magnetopause'], 'P', 'R', 'V', 'K', 'Losses_c');
        else
        save_plt_4d([VERB4D_input_folder, 'Losses_magnetopause.plt'], P, R, V, K, Losses_c);
        end
        
    catch end

end


if (false)
    %%
    
    L_val = 4.5
    P_idx = 1;
    
    [tmp, dxx_L_idx] = min(abs(L_chorus.arr(:,1,1) - L_val));
    
    f1 = figure('Units', 'inches', 'Position', [1. 1. 8 5], ...
    'DefaultAxesFontName', 'times new roman', 'DefaultAxesFontWeight', 'bold', 'DefaultAxesFontSize', 10, 'DefaultTextFontWeight', 'bold', 'DefaultTextFontSize', 10,...
    'PaperOrientation', 'portrait', 'PaperPositionMode', 'auto', 'DefaultLineLineWidth', 2);%, 'PaperPosition', [1 1 3.8 9]);%

    pcolor(squeeze(al.arr(P_idx, L_idx, :, :)), squeeze(en.arr(P_idx, L_idx, :, :)), log10(squeeze(-Losses.arr(P_idx, L_idx, :, :))));

    set(gca, 'yscale', 'log')
    %shading flat
    %caxis([-1 1])
    colorbar
    
    xlim([0 alc(L_val)])

end
