%% Calculate L*, en, al, and Jacobians

import plasma.*

import read_write.load_4d
import read_write.save_plt_4d

load('VERB4D_prep')
load([VERB4D_prep_folder, 'grid'])

%% Calculate pitch-angles and energy
[al.arr, Bounce_time_dimentionless.arr] = Dip.calc_al_Dip(K.arr, R.arr);
save([VERB4D_prep_folder, 'Bounce_time_dimentionless'], 'Bounce_time_dimentionless')

mu.arr = V.arr ./ (K.arr + g_shift).^2;
pc.arr = muAlBf2pc(mu.arr, al.arr, Dip.B_Dip(R.arr));
en.arr = Kfunc(pc.arr);

%% Calc L*
% In dipole field L = R
L = R;
L.name = 'L*';
mkdir([VERB4D_input_folder, 'B_field'])
%save_plt_4d([VERB4D_input_folder, 'B_field/Lstar.plt'], P, R, V, K, L, en, al, mu);   
if (use_matlab)
save([VERB4D_input_folder, 'B_field/Lstar'], 'P', 'R', 'V', 'K', 'L');   
else
save_plt_4d([VERB4D_input_folder, 'B_field/Lstar.plt'], P, R, V, K, L);   
end


save([VERB4D_prep_folder, 'LEA'], 'L', 'en', 'al', 'pc');

%% Jacobian
G_local.arr = ones(P.size, R.size, V.size, K.size);
G_radial.arr = ones(P.size, R.size, V.size, K.size);

mc2 = 0.511;
G_radial.arr = sqrt(8 .* mu.arr .* mc2) ./ (K.arr + g_shift).^2 ./ L.arr.^2; % Jacobian for (L, V, K) coordinates!
G_local.arr = G_radial.arr;

%G_local.name = 'G_local';
%G_radial
if (use_matlab)
save([VERB4D_input_folder, 'B_field/G_local'], 'P', 'R', 'V', 'K', 'G_local');
save([VERB4D_input_folder, 'B_field/G_radial'], 'P', 'R', 'V', 'K', 'G_radial');
else
save_plt_4d([VERB4D_input_folder, 'B_field/G_local.plt'], P, R, V, K, G_local);
save_plt_4d([VERB4D_input_folder, 'B_field/G_radial.plt'], P, R, V, K, G_radial);
end
