% Calculate L*, en, al, and Jacobians

import plasma.calc_Lstar
import plasma.muAlBf2pc
import plasma.Kfunc
import plasma.Tsy.calc_al_Tsy

import read_write.save_plt_4d

load('VERB4D_prep')
load([VERB4D_prep_folder, 'sat_data'])
load([VERB4D_prep_folder, 'grid'])
%load([VERB4D_prep_folder, 'B_field/Bf_update_time.mat'])

mkdir([VERB4D_input_folder, 'B_field'])

convenient_date = datenum([2008 03 20 5 58 51]); % A very convenient date, magnetic equator as almost at Z=0

%use_cache = false;

%for it = 1:length(Bf_update_time)
%    current_date = Bf_update_time(it);    
for Kp10 = AllKp10.arr'
    current_date = convenient_date;
    
    disp(['Calculating L-star for ', datestr(current_date), ', Kp10=', num2str(Kp10)])
    
    load([VERB4D_prep_folder, 'B_field/B_field_Kp10=', num2str(Kp10), '.mat'])
    %load([VERB4D_prep_folder, 'B_field/B_field_', datestr(current_date, 'yyyymmddHHMMss'), '.mat'])
    % B is in Tesla

    %% Calculate L*
    % Calculate trajectories from conservation of energy: mu*B + q*Pot = const or something like that
    % B should be in Gauss here

    %'!!!B = Dip!!!'
    %B.z = Dip.B_Dip(R.arr(:,:,1,1), 0, 0.29909) * 1e-4;

    %' !!!!!!!!!!!!!!!!!!! FIX TRAJECTORIES !!!!!!!!!!!!!!!!!!!!! '
    if (unique(K.arr) > 0.001)
        error('For non-equatorial particles, to find traj you need to calculate potential of the vector field');
    else
        traj = Bf.z;
    end

    traj(isnan(traj)) = 0;
    %if (R.arr(1) == 1)
    %    B0 = max(Bf.z(:));
    %else
    %    error('Need to specify B0 for L* calc AS ACCURATE AS POSSIBLE')
    %end
    B0 = 0.2982e-4;
    [L_bmin_onera.arr, Phi_bmin_onera.arr] = calc_Lstar(P.arr(:,:,1,1), R.arr(:,:,1,1), Bf.z, traj, B0);
    L_bmin_onera.name = 'L*';

    %L_bmin_onera(L_bmin_onera < 1) = NaN;

    % 'Fix' L-star - it should increase with distance
    if (true)
        for iP = 1:length(P.arr(:,1,1,1))
            for iR = 2:length(R.arr(1,:,1,1))
                if (L_bmin_onera.arr(iP,iR) <= L_bmin_onera.arr(iP,iR-1))
                    L_bmin_onera.arr(iP,iR) = L_bmin_onera.arr(iP,iR-1)*1.001;
                end
            end    
        end
    end
    
    % Very rarely for some reasons there are NaNs
    if (any(isnan(L_bmin_onera.arr(:))))
        warning('L* contains NaNs!')
        L_bmin_onera.arr(isnan(L_bmin_onera.arr)) = interp1(find(~isnan(L_bmin_onera.arr)), L_bmin_onera.arr(~isnan(L_bmin_onera.arr)), find(isnan(L_bmin_onera.arr)), 'PCHIP');
    end
    
    L.arr = repmat(L_bmin_onera.arr, [1 1 V.size K.size]);
    %L.arr = smooth2(L.arr, 1, 1); % smooth
    
    %' !!!!!!!!!!!!!!! L* = R !!!!!!!!!!!!!!!!!!'
    %L.arr = R.arr;
    
    save_plt_4d([VERB4D_input_folder, 'B_field/Lstar_Kp10=', num2str(Kp10), '.plt'], P, R, V, K, L);   
    %save_plt_4d([VERB4D_input_folder, 'B_field/Lstar_', datestr(current_date, 'yyyymmddHHMMss'), '.plt'], P, R, V, K, L);   
    
    if (false)
        %%
        [X.arr, Y.arr] = pol2cart(P.arr(:,:,1,1), R.arr(:,:,1,1));

        figure
        pcolor(X.arr, Y.arr, L.arr - R.arr); caxis([-0.1 0.1])
        shading('interp')
        %pcolor(X.arr, Y.arr, L.arr);
        %pcolor(X.arr, Y.arr, Bf.z - Dip.B_Dip(R.arr, 0, B0)); caxis([-0.1 0.1])
        set(gca, 'xDir', 'reverse', 'yDir', 'reverse')

        colorbar

        return
    end
    
    %% Calculate pitch-angles on the grid
    disp(['Calculating pitch-angles and bounce-time for ', datestr(current_date)])
    try
        if (use_cache)
            %load([VERB4D_prep_folder, 'B_field/al_Bounce_time_dimentionless_', datestr(current_date, 'yyyymmddHHMMss'), '.mat'])
            load([VERB4D_prep_folder, 'B_field/al_Bounce_time_dimentionless_Kp10=', num2str(Kp10), '.mat'])
        else
            a(-1)
        end
    catch
        %load([VERB4D_prep_folder, 'Field_line_arr'])
        %load([VERB4D_prep_folder, 'B_field/Field_line_arr_', datestr(current_date, 'yyyymmddHHMMss'), '.mat'])
        load([VERB4D_prep_folder, 'B_field/Field_line_arr_Kp10=', num2str(Kp10), '.mat'])
        %[al, Bounce_time_dimentionless] = calc_al_Tsy(V, K, kext, internal_field, current_date, maginput, Bf, Bmin_surface, Field_line_arr);
        [al, Bounce_time_dimentionless] = calc_al_Tsy(K, kext, internal_field, current_date, maginput, Bf, Bmin_surface, Field_line_arr);
        %save(['VERB4D_prep/B_field/al_Bounce_time_dimentionless_', datestr(current_date, 'yyyymmddHHMMss'), '.mat'], 'al', 'Bounce_time_dimentionless')
        save([VERB4D_prep_folder, 'B_field/al_Bounce_time_dimentionless_Kp10=', num2str(Kp10), '.mat'], 'al', 'Bounce_time_dimentionless')
    end

    %%
    %pc.arr = mu2pc(L_bmin_onera.arr, mu.arr, al.arr);
    mu.arr = V.arr ./ (K.arr + g_shift).^2;
    pc.arr = muAlBf2pc(mu.arr, al.arr, repmat(Bf.z.*1e4, [1 1 V.size K.size]));
    en.arr = Kfunc(pc.arr);

    %save([VERB4D_prep_folder, 'B_field/LEA_', datestr(current_date, 'yyyymmddHHMMss'), '.mat'], 'L', 'en', 'al', 'pc')
    save([VERB4D_prep_folder, 'B_field/LEA_Kp10=', num2str(Kp10), '.mat'], 'L', 'en', 'al', 'pc')

    disp(['Calculating Jacobians for ', datestr(current_date)])

    % Jacobian
    G_local.arr = ones(P.size, R.size, V.size, K.size);
    G_radial.arr = ones(P.size, R.size, V.size, K.size);

    mc2 = 0.511;
    G_radial.arr = sqrt(8 .* mu.arr .* mc2) ./ (K.arr + g_shift).^2 ./ L.arr.^2; % Jacobian for (L, V, K) coordinates!
    G_local.arr = sqrt(8 .* mu.arr .* mc2) ./ (K.arr + g_shift).^2 ./ R.arr.^2; % Jacobian for (R, V, K) coordinates!

    %G_local.name = 'G_local';
    %G_radial
    %save_plt_4d([VERB4D_input_folder, 'B_field/G_local_', datestr(current_date, 'yyyymmddHHMMss'), '.plt'], P, R, V, K, G_local);
    %save_plt_4d([VERB4D_input_folder, 'B_field/G_radial_', datestr(current_date, 'yyyymmddHHMMss'), '.plt'], P, R, V, K, G_radial);
    save_plt_4d([VERB4D_input_folder, 'B_field/G_local_Kp10=', num2str(Kp10), '.plt'], P, R, V, K, G_local);
    save_plt_4d([VERB4D_input_folder, 'B_field/G_radial_Kp10=', num2str(Kp10), '.plt'], P, R, V, K, G_radial);

end
    




