%% 
% Saves magnetic field in the equatorial plane  into a file

import plasma.*

disp('Calculating magnetic field (dipole field)');

% Loading general parameters
load('VERB4D_prep')

% Loading grid
load([VERB4D_prep_folder, 'grid'])

% P is in rad
% R is in Re
% V is in MeV * Re^2
% K is in G^{0.5} Re
% mu is in MeV / G 

% Magnetic field, 2D  in P and R  array
Bf.p = zeros(size(R.arr));
Bf.r = zeros(size(R.arr));
Bf.z = Dip.B_Dip(R.arr(:,:,1,1), 0, 0.29909) * 1e-4; % Tesla!!!
Bf.z = repmat(Bf.z, [1 1 V.size K.size]);
save([VERB4D_prep_folder, 'B_field.mat'], 'Bf')
