%% Calculating electric field

disp('Calculating electric field')

import plasma.calc_E_field_VS

load('VERB4D_prep')
load([VERB4D_prep_folder, 'grid'])
load([VERB4D_prep_folder, 'sat_data'])

mkdir([VERB4D_prep_folder, 'E_field']);
for Kp10 = AllKp10.arr'

    disp(['Calculate electric field for Kp10=', num2str(Kp10)]);
    
    [Ef, Pot] = calc_E_field_VS(P, R, Kp10/10);
    [E_m, Pot_m] = calc_E_field_VS(P, R, Kp10/10, 'conv');
    [E_c, Pot_c] = calc_E_field_VS(P, R, Kp10/10, 'corr');
    
    % Save electric field for each Kp
    save([VERB4D_prep_folder, 'E_field/E_field_Kp10=', num2str(Kp10), '.mat'], 'Ef', 'Pot', 'E_m', 'E_c', 'Pot_m', 'Pot_c');
    
end    

%plotting.plot_E_field(P, R, Pot, Pot_m, Pot_c);
