classdef GridDxx < handle & dynamicprops & matlab.mixin.Copyable
    %GRIDDXX Stores the diffusion coefficients
    %   
    
    properties
        type;
        Grid;
        
        wave; % name of the wave
        
        Log = VERB_Classes.Logger('mlog.txt');
    end
    
    methods
        function obj = GridDxx(type)
           obj.Grid = VERB_Classes.Grid();
           obj.type = type;
            
            switch type
                case 'leq'
                   	obj.addprop('Daa');
                    obj.addprop('Dpp');
                    obj.addprop('Dpa');
                case 'lvk'
                    obj.addprop('Dkk');
                    obj.addprop('Dvv');
                    obj.addprop('Dvk');
                otherwise
                        obj.Log.Error('Unknown type. Only leq and lvk are allowed');
            end
        end
    end
    
end

