classdef GridVariable < VERB_Classes.Variable
    %GRIDVARIABLE Class that stor variable and it's grid
    %   
    
    properties
        Grid; % object of class Grid();
    end
    
    methods
        function obj = GridVariable(varargin)
            % GridVariable(Variable, Grid)
            if(nargin == 2)
                var = varargin{1};
                grid = varargin{2};
                obj.copy_variabe_grid(var,grid);
                obj.grid = obj.Grid.type;
            else
                return;
            end
            
        end
        
        function copy_variabe_grid(obj,varargin)
            if(nargin == 3)
                var = varargin{1};
                grid = varargin{2};
            elseif(isa(varargin{1},'VERB_Classes.GridVariable'))
                var = varargin{1};
                grid = varargin{1}.Grid;
            end
            
            obj.val = var.val;
            obj.name = var.name;
            obj.units = var.units;
            obj.description = var.description;
            obj.grid = var.grid;
          
            obj.dependence = var.dependence;
            obj.originalFile = var.originalFile;
            obj.version = var.version;
            obj.gridCode = var.gridCode;            
            
            obj.Grid = grid; % TODO: check that grid is a Grid class object
        end
        
        function O = get_slice_by_variable_index(obj,varName,varIndex)
            % funciton return a permuted slice as a GridVariable object for
            % the specific index of the specific variable
            % get_slice_by_variable_index('Energy',1)
            % get_slice_by_variable_index('Energy','end')
            
            % realization for only one variable
            %varName  = varargin{1};
            %varIndex = varargin{2};
            
            if(~isprop(obj.Grid,varName))
                obj.Log.Error(['Property ' varName ' not found in the Grid']);
            end
            
            if(strcmp(varIndex,'end') )
                varIndex = obj.Grid.(varName).size;
            end
            
            % reduce the grid str
            gridstr = strrep(obj.grid, obj.Grid.(varName).grid, '');
            
            % find the position of the variable
            idx     = obj.Grid.get_index_by_code(obj.Grid.(varName).grid);
            
            % determine the dimention of the GridVariable
            ndim    = numel(obj.size); 
            % column string
            cstr    = cell(1,ndim);
            cstr(:) = {':'}; % filed by :
            % put the index in the correct position
            cstr{idx} = num2str(varIndex);
            % now make actual string
            cstr = ['(' strjoin(cstr,',') ')']; % wraper is ready
            
            % for with the variable
            variable = VERB_Classes.Variable(obj.val,obj.name,gridstr,obj.units,obj.description);
            sizeArr = obj.size; sizeArr(idx) = [];
            if(size(sizeArr,2) > 1)
                eval(['variable.val = reshape(variable.val' cstr ', sizeArr);']);
            else
                eval(['variable.val = squeeze(variable.val' cstr ');']);
            end
            
            varArr = cell(ndim - 1, 1); % array of the variables
            varArrIdx = 0;
            % for with variables
            for iVar = 1:ndim
                if( ~strcmp(obj.Grid.vars{iVar},varName) )
                    varArrIdx = varArrIdx +1;
                    varArr{varArrIdx} = obj.Grid.(obj.Grid.vars{iVar}).copy;
                    if(size(sizeArr,2) > 1)
                        eval(['varArr{varArrIdx}.val = reshape(varArr{varArrIdx}.val' cstr ', sizeArr);']  );
                    else
                        eval(['varArr{varArrIdx}.val = squeeze(varArr{varArrIdx}.val' cstr ');']  );
                    end
                end
            end
            
            O = VERB_Classes.GridVariable(variable,VERB_Classes.Grid(varArr{:}));
            % fix the values, because thay rebuilt in the constructor
            for iVar = 1:numel(varArr)
              O.Grid.(varArr{iVar}.name).val = varArr{iVar}.val;
            end            
            
        end
    end
    
end

