classdef PltFile < VERB_Classes.VERBFile
    %PLTFILE Manupulates with plt files
    
    properties
    end
    
    methods
        function obj = PltFile(varargin)
            obj = obj@VERB_Classes.VERBFile();
            
            import read_write.save_plt_4d;
            import read_write.save_plt_lpa;
        end
        
        function check_data(obj)
            % data for plt should be GridVariable
            
        end
        
        function save_file(obj) 
            
            % save_plt_4d([DiffCoeff_output_folder, 'Daa_chorus_day.plt'], P, L, pc, al, Daa_chorus_day_4D);
            % var.name, var.arr, var.comments
            
            Q1 = data.Grid.get_field_by_index(1);
            Q2 = data.Grid.get_field_by_index(2);
            Q3 = data.Grid.get_field_by_index(3);
            Q4 = data.Grid.get_field_by_index(4);
            V.arr   = data.val;
            V.name  = data.name;
            
            save_plt_4d([obj.filePath, obj.fileName], Q1, Q2, Q3, Q4, V);
            
        end
        
        function data = load_file(obj,varargin)
            % First parameter - coordinates
            % Secont - data
            import read_write.load_plt;
            import read_write.load_4d;
            
            fullFile = [obj.filePath, obj.fileName];
            
            outputVar  = varargin{:}{1};
            outputData = varargin{:}{2};
                if(~iscell(outputData))
                    % need if the input is a single string
                     outputData = {outputData};
                end
            
            if(numel(outputVar) == 3),               
                %load_plt(fullFile, 'make3D');
                %eval(['[' strjoin(outputVar,',') ',' strjoin(outputData,',') ']  = load_plt(fullFile, ''make3D'');']);
                [Q{1}, Q{2}, Q{3}, D1]  = load_plt(fullFile, 'make3D');
                
                vars = cell(numel(outputVar),1);
                gridstr ='';
                for iV = 1:numel(outputVar)
                    vars{iV} = VERB_Classes.Variable(Q{iV}.arr,outputVar{iV});
                    gridstr = [gridstr vars{iV}.grid];
                end

                data = VERB_Classes.GridVariable(VERB_Classes.Variable(D1.arr,outputData{1},gridstr,'',''),VERB_Classes.Grid(vars{}));
                elseif(numel(outputVar) == 4),
                
                 disp('TBD!');       
            
            end
            
        end
        
        
    end
    
end

