classdef VERBFile < handle
    %VERBFILE Save and load VERB files
    %   
    
    properties
        data; % Store the variable that have to be saved or loaded
        
        fileName; % name of the file
        filePath; % path to the file
        
    end
    
    methods
        function obj = VERBFile(varargin)
            switch nargin
                case 1
                    obj.fileName = varargin{2};
                case 2
                    obj.fileName = varargin{2};
                    obj.filePath = varargin{3};                    
            end
        end
        
        function save(obj,varargin)
            switch nargin
                case 1
                    obj.data = varargin{1};
            end
            
            % check the file
            % ...
            
            obj.check_data; % check the data
            
            obj.save_file;
        end
        
        function data = load(obj, varargin)
            
            data = obj.load_file(varargin);
        end
    end
    
    methods (Abstract)
        check_data(obj); % check the data
        data = load_file(obj); % load the file
        save_file(obj); % save the file
    end
    
end

