function plugin_BC_standart_BC( obj,varargin )
%PLUGINBC_BC_STANDART_BC Summary of this function goes here
%   Detailed explanation goes here

if(~strcmp(obj.PSD0.PSD.Grid.type , 'plvk' ) )
    obj.Log.Error('standard BC pulgin cannot work with grid other that plvk');
end
    
obj.Ll = obj.PSD0.PSD.get_slice_by_variable_index( 'L_Star'  , 'end' ); 
obj.Lu = obj.PSD0.PSD.get_slice_by_variable_index( 'L_Star'  ,   1 );

obj.Rl = obj.PSD0.PSD.get_slice_by_variable_index( 'L_Star'  , 'end' );
obj.Ru = obj.PSD0.PSD.get_slice_by_variable_index( 'L_Star'  ,   1 );

obj.Kl = obj.PSD0.PSD.get_slice_by_variable_index( 'K'  , 'end' );
obj.Ku = obj.PSD0.PSD.get_slice_by_variable_index( 'K'  ,   1 );

obj.Vl = obj.PSD0.PSD.get_slice_by_variable_index( 'V'  , 'end' );
obj.Vu = obj.PSD0.PSD.get_slice_by_variable_index( 'V'  ,   1 );

% Adjust the BC
  obj.Vu.val(:) = 1e-21;
  obj.Kl.val(:) = 1e-21;
  obj.Ku.val(:) = 0;
  
obj.Ru.name = 'Ru';obj.Ru.description = 'Radial upper boundary condition';  
obj.Rl.name = 'Rl';obj.Rl.description = 'Radial lower boundary condition';  
obj.Lu.name = 'Lu';obj.Lu.description = 'L* upper boundary condition';  
obj.Ll.name = 'Ll';obj.Ll.description = 'L* lower boundary condition';  
obj.Ku.name = 'Ku';obj.Ku.description = 'K upper boundary condition';  
obj.Kl.name = 'Kl';obj.Kl.description = 'K lower boundary condition';  
obj.Vu.name = 'Vu';obj.Vu.description = 'V upper boundary condition';  
obj.Vl.name = 'Vl';obj.Vl.description = 'V lower boundary condition';  

obj.Lu = VERB_Classes.GridVariableBC(obj.Lu, 'BCT_CONSTANT_VALUE');
obj.Ll = VERB_Classes.GridVariableBC(obj.Ll, 'BCT_CONSTANT_VALUE');
obj.Ru = VERB_Classes.GridVariableBC(obj.Ru, 'BCT_CONSTANT_VALUE');
obj.Rl = VERB_Classes.GridVariableBC(obj.Rl, 'BCT_CONSTANT_VALUE');
obj.Ku = VERB_Classes.GridVariableBC(obj.Ku, 'BCT_CONSTANT_DERIVATIVE');
obj.Kl = VERB_Classes.GridVariableBC(obj.Kl, 'BCT_CONSTANT_VALUE');
obj.Vu = VERB_Classes.GridVariableBC(obj.Vu, 'BCT_CONSTANT_VALUE');
obj.Vl = VERB_Classes.GridVariableBC(obj.Vl, 'BCT_CONSTANT_VALUE');

end

