function plugin_Local_prvk_Coordinates( obj, varargin )
%PLUGIN_LOCAL_PRVK_COORDINATES calculate cooridnates for local grid based
%on prvk grid

    import plasma.Dip.calc_al_Dip;
    import plasma.muAlBf2pc;
    import plasma.pc2en;

   
    obj.Local.V = VERB_Classes.GridVariable(obj.LocalGrid.Grid.V,obj.LocalGrid.Grid);
    obj.Local.K = VERB_Classes.GridVariable(obj.LocalGrid.Grid.K,obj.LocalGrid.Grid);
    
    % V=(K + g_shift)^2 * mu, We melive that g_shift = 0.5
    % Mu = V/(K+g_shift).^2;
    
    g_shift = 0.5;
    

    MuVal     = obj.Local.V.val./(obj.Local.K.val+g_shift).^2;
    
    % At that moment we calculate it based on Dip field.
    AlphaVal  = calc_al_Dip(obj.Local.K.val, obj.Local.K.Grid.R.val);
    
    PCVal     = muAlBf2pc (MuVal, AlphaVal, obj.Field.Bf.B.val);
    
    EnergyVal = pc2en(PCVal);
    
    
    
    Mu     = VERB_Classes.Variable(MuVal,'Mu','m','MeV/G','Adiabatic invariant');
    PC     = VERB_Classes.Variable(PCVal,'PC','p','MeV','PC');
    Energy = VERB_Classes.Variable(EnergyVal,'Energy','e','MeV','Energy');
    Alpha  = VERB_Classes.Variable(AlphaVal,'Alpha','q','rad','Equatorial Pitch Angle');
    
    obj.Local.PC     = VERB_Classes.GridVariable(PC,obj.LocalGrid.Grid);
    obj.Local.Mu     = VERB_Classes.GridVariable(Mu,obj.LocalGrid.Grid);
    obj.Local.Energy = VERB_Classes.GridVariable(Energy,obj.LocalGrid.Grid);
    obj.Local.Alpha  = VERB_Classes.GridVariable(Alpha,obj.LocalGrid.Grid);
end

