function plugin_Radial_plvk_Coordinates( obj, varargin )
%PLUGIN_RADIAL_PLVK_COORDINATES calculate cooridnates for radial grid based
%on plvk grid

    import plasma.Dip.calc_al_Dip;
    import plasma.muAlBf2pc;
    import plasma.pc2en;

   
    obj.Radial.V = VERB_Classes.GridVariable(obj.RadialGrid.Grid.V,obj.RadialGrid.Grid);
    obj.Radial.K = VERB_Classes.GridVariable(obj.RadialGrid.Grid.K,obj.RadialGrid.Grid);
    
    % V=(K + g_shift)^2 * mu, We melive that g_shift = 0.5
    % Mu = V/(K+g_shift).^2;
    
    g_shift = 0.5;
    

    MuVal     = obj.Local.V.val./(obj.Radial.K.val+g_shift).^2;
    
    % At that moment we calculate it based on Dip field.
    AlphaVal  = calc_al_Dip(obj.Radial.K.val, obj.LocalGrid.Grid.R.val); % Points on Local Grid match to the points on Radial Grid, hopefully...
    
    PCVal     = muAlBf2pc (MuVal, AlphaVal, obj.Field.Bf.B.val);
    
    EnergyVal = pc2en(PCVal);
    
    
    
    Mu     = VERB_Classes.Variable(MuVal,'Mu','m','MeV/G','Adiabatic invariant');
    PC     = VERB_Classes.Variable(PCVal,'PC','p','MeV','PC');
    Energy = VERB_Classes.Variable(EnergyVal,'Energy','e','MeV','Energy');
    Alpha  = VERB_Classes.Variable(AlphaVal,'Alpha','q','rad','Equatorial Pitch Angle');
    
    obj.Radial.PC     = VERB_Classes.GridVariable(PC,obj.RadialGrid.Grid);
    obj.Radial.Mu     = VERB_Classes.GridVariable(Mu,obj.RadialGrid.Grid);
    obj.Radial.Energy = VERB_Classes.GridVariable(Energy,obj.RadialGrid.Grid);
    obj.Radial.Alpha  = VERB_Classes.GridVariable(Alpha,obj.RadialGrid.Grid);
end

