function plugin_DLL_brautigam_albert_DLL( obj, varargin)
%PLUGIN_DLL_BRAUTIGAM_ALBERT_DLL DLL based on Brautigam and Albert
    import diff_coeff.calc_DLL;
    
    p = inputParser;
    addParameter(p,'Kp0',4);    
    parse(p,varargin{:});
    Kp0 = p.Results.Kp0;
    
    
    Dll = VERB_Classes.Variable(zeros(obj.RadialGrid.Grid.size),'Dll','','days^{-1}','Radial diffusion coefficient based on Brautigam and Albert [2000] estimation');
    Dll.val = calc_DLL(Kp0, obj.RadialGrid.Grid.L_Star.val);    
    
    obj.Dll = VERB_Classes.GridVariable(Dll,obj.RadialGrid.Grid);
    
end

