function plugin_KP_server_Index( obj, varargin )
%PLUGIN_KP_SERVER_INDEX Load KP from the server
%
%  Config.ini parameters:
%
%  KpFileName     % name of the kp matlab file
%  KpServer       % path to the server
%  KpFileLocation % path to the folder of the kp matlab file


    p = inputParser;
    addParameter(p,'KpServer','z:\');    
    addParameter(p,'KpFileLocation','Kp/Kp_archive');
    addParameter(p,'KpFileName','kp_all.mat');
    parse(p,varargin{:});
    KpServer = p.Results.KpServer;
    KpFileLocation = p.Results.KpFileLocation;
    KpFileName = p.Results.KpFileName;

    KpFile = fullfile(KpServer,KpFileLocation,KpFileName);

    if(exist(KpFile,'file'))
        load(KpFile);
    else
        obj.Log.error(['Kp file not found: ' KpFile]);
    end
    
    obj.KP_var(kp_time,kp_index./10);
end

