function plugin_Grid_prvk_LocalGrid( obj, varargin )
%PLUGIN_GRID_PRVK_LOCALGRID create grid from V and K vectors

    if(~obj.V.check_fields)
        obj.Log.error('V fields check error');                
    end
    
    if(~obj.K.check_fields)
        obj.Log.error('K fields check error');                
    end

    obj.V.set_variable(VERB_Classes.Variable([],'V','v','R_{e} MeV G','Combination of invariants V=Mu*(K+0.5)^2'));	
    obj.K.set_variable(VERB_Classes.Variable([],'K','k','R_{e}^{0.5}G','K invariant'));
    obj.V.vector();
    obj.K.vector();
    
    obj.Grid = VERB_Classes.Grid(obj.PreGrid.Phi, obj.PreGrid.R, obj.V, obj.K);
end

