function plugin_PSD_steady_state_PSD0( obj, varargin)
%PLUGIN_PSD_STEADY_STATE_PSD0 Summary of this function goes here
%   Detailed explanation goes here
    import VERB4D_scripts.initial_PSD_3D

    p = inputParser;
    addParameter(p,'Kp0',4);    
    parse(p,varargin{:});
    Kp0 = p.Results.Kp0;
    
    tau = 4/Kp0;

    PSD = VERB_Classes.Variable(zeros(obj.RadialGrid.Grid.size),'PSD','','VERB units','PSD based on steady state');
    
    %size0 = obj.LocalGrid.Grid.size;
    %size2 = size0(2);
    %size3 = size0(3);
    %size4 = size0(4);
    %L_Star = obj.RadialGrid.Grid.L_Star.val; % needs  to be changed in future
    
    for iP=1:obj.RadialGrid.Grid.Phi.size
        
        PC          = obj.Coordinates.Radial.PC.get_slice_by_variable_index('Phi',iP);
        Alpha       = obj.Coordinates.Radial.Alpha.get_slice_by_variable_index('Phi',iP);
        RadialSlice = obj.RadialGrid.Grid.get_slice_by_variable_index('Phi',iP); 
    
        PSD.val(iP,:, :, :) = initial_PSD_3D(RadialSlice.L_Star.val, PC.val, Alpha.val, Kp0, tau);
    end
    
    obj.PSD = VERB_Classes.GridVariable(PSD,obj.RadialGrid.Grid);
    obj.PSD.grid = obj.RadialGrid.Grid.type;
end

