classdef Bf < VERB_Modules.Module
    %BF Module calculate magnetic field
    %   Detailed explanation goes here
    
    properties
        Time;
        LocalGrid;
        Index;        
        
        % the actual variable that have the field
        B;
        
        % configuration
        pluginBf;
    end
    
    methods
        function obj = Bf(manager)
             % call paraent
            obj = obj@VERB_Modules.Module(manager);
            obj.Time      = VERB_Modules.Time(manager);    
            obj.LocalGrid = VERB_Modules.LocalGrid(manager);   % 
            obj.Index     = VERB_Modules.Index(manager); %
            
            % Initialization            
            obj.clear;
        end
        
        function clear(obj)
            obj.B = VERB_Classes.GridVariable(VERB_Classes.Variable([],'B','','G','Magnetic field') , VERB_Classes.Grid());
        end
        
        function load(obj,varargin)
            obj.Time      = obj.manager.Time;
            obj.LocalGrid = obj.manager.LocalGrid;
            obj.Index     = obj.manager.Index;
            
            obj.clear;
        end
        
        function run(obj)
            obj.run_plugin('pluginBf','B');
        end
        
        function save(obj)
        end
           
    end
    
end

