classdef Coordinates < VERB_Modules.Module
    %Coordinates calculate invarians or coordinates based on the grid
    %   
    
    properties
        %Modules
        LocalGrid;  % Local  Grid
        RadialGrid; % Radial Grid
        Time;       % Coordinates may change with time
        Field;      % We need field to calculate invariantes
        
        % Coordinates (should be local and radial)
        Local;
        Radial;
    end
    
    methods
        function obj = Coordinates(manager)
            % call paraent
            obj = obj@VERB_Modules.Module(manager);            
            obj.Time = VERB_Modules.Time(manager);
            obj.LocalGrid = VERB_Modules.LocalGrid(manager);
            obj.RadialGrid = VERB_Modules.RadialGrid(manager);
            obj.Field = VERB_Modules.Field(manager);
            
            
            % Initialization/clear
            obj.clear;
        end
        
        function clear(obj)
            obj.Local = VERB_Classes.GridCoordinates();
            obj.Radial = VERB_Classes.GridCoordinates();
        end
        
        function load(obj, varargin)
            % Clear
            obj.clear;
            
            obj.LocalGrid  = obj.manager.LocalGrid;  % Local  Grid
            obj.RadialGrid = obj.manager.RadialGrid; % Radial Grid
            obj.Time       = obj.manager.Time;       % Coordinates may change with time
            obj.Field      = obj.manager.Field;      % Calculation of the coordinates is based on field
        end
        
        function run(obj)
            
            % Calculate all variables for local grid based on the grid type
            obj.run_plugin('LocalGrid.Grid.type','Local');
            
            % Calculate all variables for radial grid based on the grid type
            obj.run_plugin('RadialGrid.Grid.type','Radial');
            
            
        end
        
        function save(obj)
        end
        
    end
    
end

