classdef DLL < VERB_Modules.Module
    %DLL Module for Radial diffusion coefficient
    
    properties
        RadialGrid; % Radial Grid
        Time;       % Time
        Index;
        MP;
        PreDLL;
        
        pluginDLL;
        
        Dll; % Diffusion coefficient
 
    end
    
    methods
        function obj = DLL(manager)
            % call paraent
            obj = obj@VERB_Modules.Module(manager);              
            obj.Time = VERB_Modules.Time(manager);
            obj.RadialGrid = VERB_Modules.RadialGrid(manager);
            obj.Index = VERB_Modules.Index(manager);
            obj.PreDLL = VERB_Modules.PreDLL(manager);
            obj.MP = VERB_Modules.MP(manager);
            
            obj.clear;
        end
        
        function clear(obj)
            obj.Dll = VERB_Classes.GridVariable();
        end
        
        function load(obj, varargin)
            obj.clear;
            
            obj.RadialGrid = obj.manager.RadialGrid; % Radial Grid
            obj.Time       = obj.manager.Time;       % Coordinates may change with time
            obj.Index      = obj.manager.Index;
            obj.MP         = obj.manager.MP;
            obj.PreDLL     = obj.manager.PreDLL;

        end
        
        function run(obj)
            obj.run_plugin('pluginDLL','DLL');
        end
        
        function save(obj)
        end
 
    end
    
end

