classdef DXX < VERB_Modules.Module
    %DXX Module local diffusion coefficients
    
    properties
        RadialGrid; % Radial Grid
        LocalGrid;  % Local Grid
        Time;       % Time
        Index;
        PP;
        Coordinates;
        PreDXX;
        
        pluginDXX; 
        
        wavesDxx; % stores the Dxx for different waves
 
    end
    
    methods
        function obj = DXX(manager)
            % call paraent
            obj = obj@VERB_Modules.Module(manager);              
            obj.Time = VERB_Modules.Time(manager);
            obj.LocalGrid  = VERB_Modules.LocalGrid(manager);
            obj.RadialGrid = VERB_Modules.RadialGrid(manager);
            obj.Index = VERB_Modules.Index(manager);
            obj.PP = VERB_Modules.PP(manager);
            obj.Coordinates = VERB_Modules.Coordinates(manager);
            obj.PreDXX = VERB_Modules.PreDXX(manager);
            
            obj.clear;
        end
        
        function clear(obj)
            %obj.Dvv = VERB_Classes.GridDxx();
            %obj.Dkk = VERB_Classes.GridDxx();
            %obj.Dvk = VERB_Classes.GridDxx();
            
            obj.wavesDxx = cell(0);
        end
        
        function load(obj, varargin)
            obj.clear;
            
            obj.LocalGrid  = obj.manager.LocalGrid;  % Local  Grid
            obj.RadialGrid = obj.manager.RadialGrid; % Radial Grid
            obj.Time       = obj.manager.Time;       % Coordinates may change with time
            obj.Index      = obj.manager.Index;
            obj.PP         = obj.manager.PP;
            obj.Coordinates = obj.manager.Coordinates;
            obj.PreDXX     = obj.manager.PreDXX;

        end
        
        function run(obj)
            obj.run_plugin('pluginDXX','DXX');
        end
        
        function save(obj)
        end
 
    end
    
end

