classdef Jacobian < VERB_Modules.Module
    %JACOBIAN calculate the local and radial Jacobian
    %   
    
    properties
        RadialGrid; % Radial Grid
        LocalGrid;  % Local Grid
        Time;       % Time
        Coordinates; % Calculated coordinates
        
        Local;  % GridJaconbian that has a Jaconbian for local grid
        Radial; % GridJaconbian that has a Jaconbian for radial grid
    end
    
    methods
        function obj = Jacobian(manager)
            % call paraent
            obj = obj@VERB_Modules.Module(manager);              
            obj.Time = VERB_Modules.Time(manager);
            obj.LocalGrid  = VERB_Modules.LocalGrid(manager);
            obj.RadialGrid = VERB_Modules.RadialGrid(manager);
            obj.Coordinates = VERB_Modules.Coordinates(manager);
            
            obj.clear;
        end
        
        function clear(obj)
            obj.Local  = VERB_Classes.GridJacobian();
            obj.Radial = VERB_Classes.GridJacobian();
        end
        
        function load(obj, varargin)
            obj.clear;
            
            obj.LocalGrid  = obj.manager.LocalGrid;  % Local  Grid
            obj.RadialGrid = obj.manager.RadialGrid; % Radial Grid
            obj.Time       = obj.manager.Time;       % Coordinates may change with time
            obj.Coordinates= obj.manager.Coordinates; % Coordinates needs for computations

        end
        
        function run(obj)
            % local grid
            obj.run_plugin('LocalGrid.Grid.type','Local');
            
            % radial grid
            obj.run_plugin('RadialGrid.Grid.type','Radial');
            
        end
        
        function save(obj)
        end
        
    end
    
end

