classdef LocalGrid < VERB_Modules.Module
    %LOCALGRID Calculate 4D grid
    %   Detailed explanation goes here
    
    properties
        PreGrid; % PreGrid object
        
        Grid; % grid container
        
        pluginGrid; % string that decine the grid type
        
        V;       
        K;        
        Mu;        
        PC;        
        Energy;        
        Alpha;
    end
    
    methods
        function obj = LocalGrid(manager)
              % call paraent
            obj = obj@VERB_Modules.Module(manager);            
            obj.PreGrid = VERB_Modules.PreGrid(manager);
            
            % Initialization
            obj.V = VERB_Classes.Vector();
            obj.K = VERB_Classes.Vector();
            obj.Mu = VERB_Classes.Vector();
            obj.PC = VERB_Classes.Vector();            
            obj.Energy = VERB_Classes.Vector();
            obj.Alpha = VERB_Classes.Vector();
        end
        
        function clear(obj)
            obj.V.set_variable(VERB_Classes.Variable());
            obj.K.set_variable(VERB_Classes.Variable());
            obj.Mu.set_variable(VERB_Classes.Variable());
            obj.PC.set_variable(VERB_Classes.Variable());
            obj.Energy.set_variable(VERB_Classes.Variable());
            obj.Alpha.set_variable(VERB_Classes.Variable());
        end
        
        function load(obj,varargin)
            % Clear variables
            obj.clear;
            
            % very important to pass the dependence object
            obj.PreGrid = obj.manager.PreGrid;
        end
        
        
        function run(obj)            
            obj.run_plugin('pluginGrid','Grid');
        end
        
        
        function save(obj)
        end
    end
    
end

