classdef PP < VERB_Modules.Module
    %PP Module for Plasma Pause calculation
    
    properties
        RadialGrid; % Radial Grid
        LocalGrid;  % Local Grid
        Time;       % Time
        Index;
        Field;
        
        pluginPP; % 
        
        Lpp; % Variable for plasma pause
 
    end
    
    methods
        function obj = PP(manager)
            % call paraent
            obj = obj@VERB_Modules.Module(manager);              
            obj.Time = VERB_Modules.Time(manager);
            obj.LocalGrid  = VERB_Modules.LocalGrid(manager);
            obj.RadialGrid = VERB_Modules.RadialGrid(manager);
            obj.Index = VERB_Modules.Index(manager);
            obj.Field = VERB_Modules.Field(manager);
            
            obj.clear;
        end
        
        function clear(obj)
            obj.Lpp = VERB_Classes.Variable();
        end
        
        function load(obj, varargin)
            obj.clear;
            
            obj.LocalGrid  = obj.manager.LocalGrid;  % Local  Grid
            obj.RadialGrid = obj.manager.RadialGrid; % Radial Grid
            obj.Time       = obj.manager.Time;       % Coordinates may change with time
            obj.Index      = obj.manager.Index;
            obj.Field      = obj.manager.Field;

        end
        
        function run(obj)
            % local grid
            obj.run_plugin('pluginPP','Lpp');
            
           
        end
        
        function save(obj)
        end
 
    end
    
end

