classdef PSD0 < VERB_Modules.Module
    %PDS0 Module for Plasma Pause calculation
    
    properties
        RadialGrid; % Radial Grid
        LocalGrid;  % Local Grid
        Time;       % Time
        SatData;       
        Coordinates;
        
        pluginPSD0; % variable for the method of the calculation
        
        PSD; % VariableGrid for PSD0
 
    end
    
    methods
        function obj = PSD0(manager)
            % call paraent
            obj = obj@VERB_Modules.Module(manager);              
            obj.Time = VERB_Modules.Time(manager);
            obj.LocalGrid  = VERB_Modules.LocalGrid(manager);
            obj.RadialGrid = VERB_Modules.RadialGrid(manager);
            obj.SatData = VERB_Modules.SatData(manager);
            obj.Coordinates = VERB_Modules.Coordinates(manager);
            
            obj.clear;
        end
        
        function clear(obj)
            obj.PSD = VERB_Classes.GridVariable();
        end
        
        function load(obj, varargin)
            obj.clear;
            
            obj.LocalGrid  = obj.manager.LocalGrid;  % Local  Grid
            obj.RadialGrid = obj.manager.RadialGrid; % Radial Grid
            obj.Time       = obj.manager.Time;       % Coordinates may change with time
            obj.SatData    = obj.manager.SatData;
            obj.Coordinates = obj.manager.Coordinates;
            

        end
        
        function run(obj)
            % 
            obj.run_plugin('pluginPSD0','PSD');
           
        end
        
        function save(obj)
        end
 
    end
    
end

