classdef SL < VERB_Modules.Module
    %SL Module for Sources and Losses
    
    properties
        RadialGrid; % Radial Grid
        LocalGrid;  % Local Grid
        Time;       % Time
        Index;
        Field;
        MP;
        PP;
        SatData;
                
        Sources; % GridVariable for sources
        Losses;  % GridVariable for losses
 
    end
    
    methods
        function obj = SL(manager)
            % call paraent
            obj = obj@VERB_Modules.Module(manager);              
            obj.Time = VERB_Modules.Time(manager);
            obj.LocalGrid  = VERB_Modules.LocalGrid(manager);
            obj.RadialGrid = VERB_Modules.RadialGrid(manager);
            obj.Index = VERB_Modules.Index(manager);
            obj.Field = VERB_Modules.Field(manager);
            obj.MP = VERB_Modules.MP(manager);
            obj.PP = VERB_Modules.PP(manager);
            obj.SatData = VERB_Modules.SatData(manager);
            
            obj.clear;
        end
        
        function clear(obj)
            obj.Sources = VERB_Classes.GridVariable();
            obj.Losses  = VERB_Classes.GridVariable();
        end
        
        function load(obj, varargin)
            obj.clear;
            
            obj.LocalGrid  = obj.manager.LocalGrid;  % Local  Grid
            obj.RadialGrid = obj.manager.RadialGrid; % Radial Grid
            obj.Time       = obj.manager.Time;       % Coordinates may change with time
            obj.Index      = obj.manager.Index;
            obj.Field      = obj.manager.Field;
            obj.MP         = obj.manager.MP;
            obj.PP         = obj.manager.PP;
            obj.SatData    = obj.manager.SatData;

        end
        
        function run(obj)
            
           
        end
        
        function save(obj)
        end
 
    end
    
end

