% +DIFF_COEFF
%
% Functions, related to computation of diffusiion coefficients due to wave-particles interactions
%
% Files
%   calc_chorus_scale           - calculates scaling of chorus diffusion coefficient with Kp-index
%   calc_derivatives_LVK_LPA_3D - calculates derivatives analitically
%   calc_derivatives_ort_3D     - calculates transformation from ORTHOGONAL coordinates J to arbitrary coordinates Q in 3D space (i, J1, J2) -> (i, Q1, Q2)
%   calc_Dfe                    - calculates electrostatic radial diffusion coefficient [see Brautigam and Albert(2000), JGR]
%   calc_DLL                    - calculates magnetic component of the radial diffusion coefficient
%   calc_DLL_scale              - calculates Dll scaling of the magnetic component of the radial diffusion coefficient with Kp index
%   convert_diff_coeff          - recalculates diffusion coefficients into a 
%   coord_transform_ort         - transformation from ORTHOGONAL coordinates J to arbitrary coordinates Q
%   FixDiffCoeff_4D             - checks and fixes diffusion coeffcients
