function alpha = alc_Dip(L)
    %%
    % ALC_DIP calculates pitch-angle at the edge of loss-cone (using dipole field)
    %
    % alpha = alc(L)
    %
    % Input:
    %  L=R - distance from the Earth
    %
    % Output:
    %  alpha - pitch-angle at the edge of the loss-cone

    % Author: Yuri Shprits
    % Last change: 20014-01-01 by Dmitriy Subbotin
    % Email: subbotin@ucla.edu
    % The work was supported by:
    %   LANL grant 12-LR-235337, PI Yuri Shprits
    %   NASA grant NNX09AF51G, PI Yuri Shprits
    
    warning('VERB4D:DIPOLE', 'Using Dipole Field')

    alpha = asin((L.^(-1.5)).*((4-3./L).^(-0.25)));

end