function taulc = taulc_Dip(L, pc, al)
    %%
    % TAULC_DIP calculate something, related to bounce time, for a dipole field
    %
    % Input:
    %   L - radial distance from the Earth in Re
    %   pc = p*c = momentum * speed of light, in MeV
    %   al - pitch-angle in rad
    %
    % Output:
    %   taulc - ?????

    Re = 6.4e6;
    c_si = 3e8;
    mc2 = 0.511;

    y = sin(al);
    T_alpha = (1.38 + 0.055 * pow(y, 1/3) - 0.32 * pow(y, 1/2) - 0.037 * pow(y, 2/3) - 0.394 * y + 0.056 * pow(y, 4/3));
    taulc = 0.25 .* 4.0 .* L .* Re .* mc2 ./ pc ./ c_si .* T_alpha ./ 60 ./ 60 ./ 24;

end
