function [Bounce_period_arr, K_invariant_CGS_arr] = calc_K_Onera2_Tsy(Field_line_arr, kext, options, sysaxes, matlabd, maginput, Bmin_arr, Bmin_xGEO_arr, alpha_eq)
    %%
    % CALC_K_ONERA2_TSY A failed attempt to speed-up the code, delete this file    
    % it doesn't work
   
    % This code calculates bounce period and K invariant in the dipole and
    % Tsyganenko models. To use the code for Tsyganenko model please install
    % IRBEM library (http://craterre.onecert.fr/prbem/irbem/description.html)
    
    % Bmin_arr input is in NanoTesla!!!!
    % Equatorial surface should be in GEO coordinates

    % Output
    %   Bounce_period_arr - bounce ... time?.. in ???
    %   K_invariant_CGS_arr - invariant K in G^0.5 Re

    % Author: Dmitriy Subbotin
    % Email: subbotin@ucla.edu
    % Last change: 20014-01-01 by Dmitriy Subbotin
    % The work was supported by:
    %   LANL grant 12-LR-235337, PI Yuri Shprits
    %   NASA grant NNX09AF51G, PI Yuri Shprits

    import fields.B_dip

    plot_wrong_Bmin = false;
    ever_add_Bmin_points = false;

    if (kext ~= 4 && kext ~= 0 && kext ~= 7)
       error(['Unimlemented external field: ', num2str(kext)]); 
    end
    
    if (options(5) ~= 5)
       error(['You need to modify adding points inside the earth to use internal magnetic field other than central dipolar.']); 
       % Specifically, when you add points inside the Earth you assume that Z=0 is magnetic equator
    end
    
    if (sysaxes ~= 1)
       error(['Only GEO sysaxis waere tested, however it should be easy to modify for other syaxis.']); 
    end
    
    Re=6378*1e3;% Earth radius, meters

    Bounce_period_arr = NaN*zeros(length(alpha_eq), length(Bmin_arr)); 
    K_invariant_CGS_arr = NaN*zeros(length(alpha_eq), length(Bmin_arr));

    length_Bmin_arr = length(Bmin_arr);
    for x_ind = 1:length_Bmin_arr
        %fprintf(1, '\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%5d / %5d: (%2.1f, %2.1f, %2.1f)', x_ind, length_Bmin_arr, Bmin_xGEO_arr(x_ind,1), Bmin_xGEO_arr(x_ind,2), Bmin_xGEO_arr(x_ind,3))
        
        Bmin = Bmin_arr(x_ind);
        Bmin_xGEO = Bmin_xGEO_arr(x_ind,:);

        if (max(isnan(Bmin_xGEO)))
            %error(['NaN coordinates ', num2str(x_ind)]);
            warning(['NaN coordinates ', num2str(x_ind)])
            continue;
        end                
        
        % Load Field_line here
        Field_line = Field_line_arr(x_ind);
        if (length(Field_line.R) < 2)
            warning('R) < 2')
        end

        %% Calculade s and ds
        if (true)    
            [eq_B, eq_idx] = min(abs(Field_line.B));
            Field_line.s = zeros(size(Field_line.R));
            
            for i = 2:length(Field_line.s)-1
                dlat    = (Field_line.lat(i+1) - Field_line.lat(i-1))/2;
                dr      = (Field_line.R(i+1)   - Field_line.R(i-1))/2;
                dphi    = (Field_line.phi(i+1) - Field_line.phi(i-1))/2;                            

                ds      = sqrt(dr.^2 + Field_line.R(i).^2 * (dlat * pi/180)^2 + (Field_line.R(i) * cos(Field_line.lat(i)*pi/180) * dphi * pi/180)^2);

                Field_line.s(i) = Field_line.s(i-1) + ds;
            end
            
            Field_line.s = Field_line.s - Field_line.s(eq_idx);

            Field_line.s(1) = interp1(Field_line.lat(2:end-1), Field_line.s(2:end-1), Field_line.lat(1), 'spline');
            Field_line.s(end) = interp1(Field_line.lat(2:end-1), Field_line.s(2:end-1), Field_line.lat(end), 'spline');

            if (false)
                %%
                figure
                plot(Field_line.lat, Field_line.s);
            end
            
        end        

  %%      
        % coordinate change
        psi = zeros(size(B_field));
        psi = asin(sqrt(1-B_field./B_m)/cos(alpha_eq));
        psi(eq_idx)=pi/2;
        psi(idx_Bm)=0;

        S = 0;

        for i = eq_idx:idx_Bm

            if (i == eq_idx)
                % uncertainty 0/0 at lambda=0 (psi=pi/2) solved analytically            
                im = i; %i-1
                ip = i+1;

                ds      = abs(s(ip) - s(im)); %% abs is temorary for compatibility!!!!
                dpsi    = psi(ip) - psi(im); %% !!!!!!!! It's actually zero with central differences

                F1 = ds/dpsi * tan(alpha_eq)^2/2/eq_B; % analytic integration

                F = -F1*(psi(i+1) - psi(i));

            elseif (i == idx_Bm)

                im = i-1;
                ip = i+1;

                ds      = abs(s(im) - s(ip));
                dB      = B_field(ip) - B_field(im);

                F1 = ds/dB*cos(psi(i));

                F = -F1*(psi(i) - psi(i-1));

            else

                im = i-1;
                ip = i+1;

                ds      = abs(s(im) - s(ip));
                dB      = B_field(ip) - B_field(im);

                F1 = ds/dB*cos(psi(i));

                F = -F1*(psi(i+1) - psi(i-1));

            end

            S = S + F;

        end

        S = S/2 * cos(alpha_eq) * B_m;
%%  
        
        
        
        Bounce_period = zeros(size(alpha_eq));
        K_invariant_CGS = zeros(size(alpha_eq));
        for ia = 1:length(alpha_eq)

            [eq_B, eq_idx] = min(abs(Field_line.B));
            B_m = eq_B./sin(alpha_eq(ia)).^2; % Magnetic field at mirror point in T
                        
            % eq_idx is new
            [eq_B, eq_idx] = min(abs(Field_line.B));
            
            if (alpha_eq(ia) > pi/2 + 1e-4)
                error(['Pitch-angle > 90 deg: alpha = ', num2str(alpha_eq(ia)*180/pi)]);
            end

            if (isnan(alpha_eq(ia)))
                ['WARING: Pitch-angle(', num2str(ia), ') is NaN; coords: ', num2str(Bmin_xGEO_arr)]
                return
            end

            %if (abs(alpha_eq(ia) - pi/2) < 1e-4)
            %if (alpha_eq(ia) >= 1.5597)
            %alpha_tmp_max = 1.5517;
            alpha_tmp_max = 87.0 * pi/180;
            if (alpha_eq(ia) > alpha_tmp_max)
                % put NaN here, cause calculation is incorrect anyway
                % we'll interpolato to these values later
                Bounce_period(ia) = NaN;
                K_invariant_CGS(ia) = NaN;
                continue                
            end            
            
            
            % B increases realy fast toward the earth,
            % Let's include only points we need to the interpolation
            idx = find(Field_line.B < B_m);
            if (length(idx) == 0)
                idx = eq_idx;
            end
            limit_north_idx = max(min(idx)-2, 1);
            limit_south_idx = min(max(idx)+2,length(Field_line.B));

            %limit_north_idx = 1;
            %limit_south_idx = length(Field_line.B);
            
            %lat_m_north = fzero(@(x)func_tmp(x, alpha_eq(ia), Field_line), [Field_line.lat(eq_idx) Field_line.lat(1)]); % Mirror point 2, degree 
            %lat_m_south = fzero(@(x)func_tmp(x, alpha_eq(ia), Field_line), [Field_line.lat(end) Field_line.lat(eq_idx)]); % Mirror point 1, degree 
            
            interp_method = 'cubic'; % Cubic seems to be woring better here and more often
            %lat_m_north = interp1(Field_line.B(limit_north_idx:eq_idx), Field_line.lat(limit_north_idx:eq_idx), B_m, interp_method);
            %lat_m_south = interp1(Field_line.B(eq_idx:limit_south_idx), Field_line.lat(eq_idx:limit_south_idx), B_m, interp_method);

            %if (lat_m_north<=lat_m_south)
            %    error(['Mirror latitude error. Alpha: ', num2str(alpha_eq(ia)*180/pi), ', GEO: ', num2str(Bmin_xGEO), ', lat: ', num2str(lat_m_north), ', ', num2str(lat_m_south)])
            %end
            
            s_m_north = interp1(Field_line.B(limit_north_idx:eq_idx), Field_line.s(limit_north_idx:eq_idx), B_m, interp_method);
            s_m_south = interp1(Field_line.B(eq_idx:limit_south_idx), Field_line.s(eq_idx:limit_south_idx), B_m, interp_method);

            %idx = find(Field_line.lat <= lat_m_north & Field_line.lat >= lat_m_south);
            idx = find(Field_line.B < B_m); % we add B_m later
            north_idx = idx(idx <= eq_idx);
            south_idx = idx(idx >= eq_idx);

            north_idx = north_idx(end:-1:1); % reverse order, so equator is the first point        

            north_add = min(north_idx)-1;
            south_add = max(south_idx)+1;
            
            Bounce_period2 = quad_ba_peiod3( ...
                [Field_line.s([eq_idx+1, north_idx]),   s_m_north,      Field_line.s(north_add)], ...
                [Field_line.B([eq_idx+1, north_idx]),   B_m,            Field_line.B(north_add)], alpha_eq(ia)); % Nothern hemisphere 
            Bounce_period1 = quad_ba_peiod3( ...
                [Field_line.s([eq_idx-1, south_idx]),   s_m_south,      Field_line.s(south_add)], ...
                [Field_line.B([eq_idx-1, south_idx]),   B_m,            Field_line.B(south_add)], alpha_eq(ia)); % Nothern hemisphere         
            Bounce_period(ia)=(Bounce_period1+Bounce_period2)*4; % It is dimensionless bounce period. To get dimension you should multiply it by Re and divide by velocity, = 4 L T(y) (eq 11a, Orlova 2011)

            % Calculation of the K invariant 
            K_invariant2 = quad_K3( ...
                [Field_line.s([eq_idx+1, north_idx]),   s_m_north], ...
                [Field_line.B([eq_idx+1, north_idx]),   B_m]); % Nothern hemisphere 
            K_invariant1 = quad_K3( ... 
                [Field_line.s([eq_idx-1, south_idx]), s_m_south], ...
                [Field_line.B([eq_idx-1, south_idx]),   B_m]); % Nothern hemisphere         
            K_invariant = (K_invariant2 + K_invariant1)*Re; % In SI units (B is taken in T, Re in meters)
            K_invariant_CGS(ia) = (K_invariant2 + K_invariant1)*100; % Units G^0.5*Re

        end
        
        %interpolate over NaNs
        if (true)
            
                % equatorial pitch-angle
                d2B_ds2 = (Field_line.B(eq_idx+1) - 2*Field_line.B(eq_idx) + Field_line.B(eq_idx-1))/((Field_line.s(eq_idx+1) - Field_line.s(eq_idx-1))/2)^2;
                %d2B_ds2 = 0.5*1/(Field_line.s(eq_idx+1) - Field_line.s(eq_idx)) * ( (Field_line.B(eq_idx+1) - Field_line.B(eq_idx))/(Field_line.s(eq_idx+1) - Field_line.s(eq_idx)) - (Field_line.B(eq_idx) - Field_line.B(eq_idx-1))/(Field_line.s(eq_idx) - Field_line.s(eq_idx-1)) ) + ...
                %          0.5*1/(Field_line.s(eq_idx) - Field_line.s(eq_idx-1)) * ( (Field_line.B(eq_idx+1) - Field_line.B(eq_idx))/(Field_line.s(eq_idx+1) - Field_line.s(eq_idx)) - (Field_line.B(eq_idx) - Field_line.B(eq_idx-1))/(Field_line.s(eq_idx) - Field_line.s(eq_idx-1)) );
                %Bt_eq = 2*pi / Re * sqrt(Field_line.B(eq_idx)/(0.5 * d2B_ds2));
                Bt_eq = 2*pi * sqrt(Field_line.B(eq_idx)/(0.5 * d2B_ds2));

                K_eq_CGS = 0;                
                
                % interpolate...
                
                nan_idx = isnan(Bounce_period);
                not_nan = ~nan_idx;
                if (length(find(not_nan)) > 1)
                    Bounce_period(nan_idx) = interp1([alpha_eq(not_nan), pi/2], [Bounce_period(not_nan), Bt_eq], alpha_eq(nan_idx));
                else
                    Bounce_period(nan_idx) = Bt_eq;
                end

                nan_idx = isnan(K_invariant_CGS);
                not_nan = ~nan_idx;
                if (length(find(not_nan)) > 1)
                    K_invariant_CGS(nan_idx) = interp1([alpha_eq(not_nan), pi/2], [K_invariant_CGS(not_nan), 0], alpha_eq(nan_idx));
                else
                    K_invariant_CGS(nan_idx) = K_eq_CGS;
                end
                
        end

        Bounce_period_arr(:, x_ind) = Bounce_period; 
        K_invariant_CGS_arr(:, x_ind) = K_invariant_CGS;
    end
    

    
end


% Eq idx should be == 2
% Bm idx should be == end-1
function S = quad_ba_peiod3(s, B_field, alpha_eq)

    %[B_m, idx_Bm] = max(B_field);
    %[eq_B, eq_idx] = min(B_field);
    %% !!!!!!!!!!!!!!!
    idx_Bm = length(B_field)-1;
    B_m = B_field(idx_Bm);

    %eq_idx = 2;
    %eq_B = B_field(eq_idx);
    [eq_B, eq_idx] = min(B_field);
    
    if (eq_idx ~= 2)
        figure
        plot(lat, B_field, '-*');
        
        error(['Something is wrong: ', num2str(eq_idx)])
    end

    if (abs(eq_B/(sin(alpha_eq)^2) - B_m) > 1e-9)
        error('Something is wrong with B-mitrror'); 
    end

    % coordinate change
    psi = zeros(size(B_field));
    psi = asin(sqrt(1-B_field./B_m)/cos(alpha_eq));
    psi(eq_idx)=pi/2;
    psi(idx_Bm)=0;
    
    S = 0;
    
    for i = eq_idx:idx_Bm

        if (i == eq_idx)
            % uncertainty 0/0 at lambda=0 (psi=pi/2) solved analytically            
            im = i; %i-1
            ip = i+1;

            ds      = abs(s(ip) - s(im)); %% abs is temorary for compatibility!!!!
            dpsi    = psi(ip) - psi(im); %% !!!!!!!! It's actually zero with central differences

            F1 = ds/dpsi * tan(alpha_eq)^2/2/eq_B; % analytic integration

            F = -F1*(psi(i+1) - psi(i));
            
        elseif (i == idx_Bm)

            im = i-1;
            ip = i+1;

            ds      = abs(s(im) - s(ip));
            dB      = B_field(ip) - B_field(im);

            F1 = ds/dB*cos(psi(i));

            F = -F1*(psi(i) - psi(i-1));
            
        else

            im = i-1;
            ip = i+1;

            ds      = abs(s(im) - s(ip));
            dB      = B_field(ip) - B_field(im);

            F1 = ds/dB*cos(psi(i));

            F = -F1*(psi(i+1) - psi(i-1));
        
        end

        S = S + F;

    end

    S = S/2 * cos(alpha_eq) * B_m;
end    

function S = quad_K3(s, B_field)

    N_int = length(B_field);
    B_m = max(B_field);
    [eq_B, eq_idx] = min(B_field);
    
    if (eq_idx ~= 2)
        error('Something is wrong')
    end

    S = 0;
    ds_prev = 0;
    % Trapezoidal rule of integration    
    for i = eq_idx:N_int
                
        if (i == N_int)
            ds = NaN;
        else
            ds = abs(s(i+1) - s(i));
        end
        
        dBm = sqrt(B_m - B_field(i));

        if (i == eq_idx)
            F = dBm*ds/2;
        elseif (i == N_int)
            F = dBm*ds_prev/2;
        else
            F = dBm*(ds + ds_prev)/2;                      
        end

        S = S + F;
        
        ds_prev = ds;
    end

end    

 
