% +PLASMA
%
% Functions related to magnetospheric plasma and plasma in general
%
% Packages
%   +TSY               - Functions that use Tsyganenko field
%   +DIP               - Functions related to dipole field
%
% Files
%   calc_Coulomb       - coulomb scattering electron lifetime [Lyons and Thorne, 1973, JGR]
%   calc_E_field_VS    - calculates Volland-Stern electric field 
%   calc_Lpp           - calculates plasmapause location Lpp
%   calc_Lstar         - calcuates L* 
%   calc_Precipitation - ekectron lifetime due to scattering in plasmasphere
%   en2pc              - calculates p*c (MeV) from energy (MeV)
%   Jc2K               - calculates adiabatic invariant K 
%   K2Jc               - Calculates Jc which is J*c, where c is speed of light
%   Kfunc              - calculates energy in MeV from p*c in MeV
%   magnetopause_Shue  - calculates magnetopause following Shue et al.
%   mu2pc              - calculates pc, which is momentum * speed of light (MeV)
%   muAlBf2pc          - Calculates pc, which is momentum * speed of light (MeV)
%   pc2en              - calculates energy (MeV) from p*c (MeV)
%   pc2mu              - calculates mu in MeV / Gauss
%   pcAlBf2mu          - calculates mu in MeV / Gauss
%   pfunc              - calculates p*c (MeV) from energy (MeV)
