function Jc = K2Jc(K, mu)
    %%
    % Calculates Jc which is J*c, where c is speed of light
    %
    % Input:
    %  K in Gauss^0.5 * Re
    %  mu in MeV / Gauss
    %
    % Output:
    %  J*c in some units
    
	mc2 = 0.511;
	Jc = K.*sqrt(8.*mc2.*mu);

end