function title = name2title(name)
    %%
    % NAME2TITLE converts file name into figure title
    %
    % title = name_to_title(name) replaces: 
    %      '_' with ' '
    %	   Dxx with D_{xx}
    %      etc
    
    % Author: Dmitriy Subbotin
    % Email: subbotin@ucla.edu
    % Last change: 20014-01-01 by Dmitriy Subbotin
    % The work was supported by:
    %   LANL grant 12-LR-235337, PI Yuri Shprits
    %   NASA grant NNX09AF51G, PI Yuri Shprits
    
    name = strrep(name, '.plt', '');
    name = strrep(name, '1-88_APL', '');
    name = strrep(name, '88_APL', '');
    name = strrep(name, '_', ' ');
    name = strrep(name, 'Dpp', 'D_{pp}');
    name = strrep(name, 'Daa', 'D_{\alpha \alpha}');
    title = name;
end
