function save_picture(figure_to_save, filename, varargin)
    %%
    % Save figure into a file (or files)
    %
    % Input:
    %  figure_to_save - matlab's figure (e.g. gcf)
    %  filename - file name
    %  varargin - file formats, coma separated, e.g. 'png', 'pdf', 'epsc'...
    %

    % Author: Dmitriy Subbotin
    % Email: subbotin@ucla.edu
    % Last change: 20014-01-01 by Dmitriy Subbotin
    % The work was supported by:
    %   LANL grant 12-LR-235337, PI Yuri Shprits
    %   NASA grant NNX09AF51G, PI Yuri Shprits

    output_formats = [varargin];

    if (length(filename) == 0) error('filename is empty'); end;
    if (length(output_formats) == 0) error('output_format is empty'); end;

    for it2 = 1:length(output_formats)
	saveas(figure_to_save, [filename, '.', output_formats{it2}(1:3)], output_formats{it2});
    end

end
