% Magnetosphere plot/video
function  video_f_mlt_4D_info(f_interp, P, R, c_min, c_max, figure_title, input_folder)

    import plotting.subplot1
    import plotting.plot_earth
    
    try
        input_folder;
    catch
        input_folder = './VERB_input/';
    end

    try
        f_interp.time;
    catch
        f_interp.time = [0];
    end
    
    mkdir('./Video');
    mov = avifile('./Video/Convection.avi', 'fps', 5, 'quality', 0, 'compression', 'none');

    %%
    if(false)
        f1 = figure('Units', 'inches', 'Position', [1. 1. 8 9.5], ...
            'DefaultAxesFontName', 'times new roman', 'DefaultAxesFontWeight', 'bold', 'DefaultAxesFontSize', 10, 'DefaultTextFontWeight', 'bold', 'DefaultTextFontSize', 10,...
            'PaperOrientation', 'portrait', 'PaperPositionMode', 'auto', 'DefaultLineLineWidth', 2);%, 'PaperPosition', [1 1 3.8 9]);%
    else
            f1 = figure('Units', 'inches', 'Position', [1. 1. 6.5 5.5], ...
        'DefaultAxesFontName', 'times new roman', 'DefaultAxesFontWeight', 'bold', 'DefaultAxesFontSize', 10, 'DefaultTextFontWeight', 'bold', 'DefaultTextFontSize', 10,...
        'PaperOrientation', 'portrait', 'PaperPositionMode', 'auto', 'DefaultLineLineWidth', 2, ...
        'Color', 'white')
    end
    
    %subplot1(2,1, 'Min', [0.1 0.1], 'Max', [0.83 0.90], 'Gap', [0.01 0.1]);
    %subplot1(2);
       
       
    set(gca,'nextplot','replacechildren');
    

    [X.arr, Y.arr] = pol2cart(P.arr(:,:,1,1), R.arr(:,:,1,1));
    
    
    % plot magnetopause
    try
        IMF_Bz = load([input_folder, 'IMF_Bz.dat']);
        IMF_Dp = load([input_folder, 'IMF_Dp.dat']);
    catch
        IMF_Bz = [0, 0];
        IMF_Dp = [0, 0];
    end
    
    try DLL_scale = load([input_folder, 'DLL_B_scale.dat']); end
    try L_UBC_scale = load([input_folder, 'L_UBC_scale.dat']); end
    try chorus_scale = load([input_folder, 'Chorus_scale.dat']); end
    %Losses_scale = load([input_folder, 'Losses_scale.dat']);
        
    try
        Lpp = load([input_folder, 'Lpp.dat']);
    catch
        Lpp = [0, 1];
    end
    
    x_max = max(R.arr(:));
    x_min = -x_max;
    y_max = x_max;
    y_min = x_min;
    
    %subplot(2,1,2);
    if (false)
        subplot1(1, 1, 'Min', [0.25 0.05], 'Max', [0.75 0.49]);
    else
        subplot1(1, 1, 'Min', [0.1 0.1], 'Max', [0.85 0.9]);
    end

    
    cl = 0;
    for it = 1:length(f_interp.time)
        %it
        % magnetosphere
        %figure
        %[tmp, Lmp_it] = max(find(IMF_Bz(:, 1) <= f_interp.time(it)));

        try
            [tmp, Lmp_it] = min(find(IMF_Bz(:, 1) >= f_interp.time(it)));
            Lmp.r = magnetopause_Shue(squeeze(P.arr(:, 1, 1, 1)), IMF_Bz(Lmp_it, 2), IMF_Dp(Lmp_it, 2));
            [Lmp.x, Lmp.y] = pol2cart(squeeze(P.arr(:,1,1,1)), Lmp.r);
            Lmp.x(abs(Lmp.x)>25) = NaN; 
            Lmp.y(abs(Lmp.y)>25) = NaN;
        catch
            Lmp.x = NaN;
            Lmp.y = NaN;
            Lmp.p = NaN;
            Lmp.r(1:P.size) = 999;
        end
        
        outside.arr = zeros(P.size, R.size);
        for iP = 1:P.size
            for iR = 1:R.size
                if (R.arr(iP, iR, 1, 1) > Lmp.r(iP))
                    outside.arr(iP, iR) = 1; 
                end
            end
        end    

        %subplot1(1, 2, 'Min', [0.1 0.05], 'Max', [1.05 0.49], 'Gap', [0.1 0.01]);
        subplot1(1);
        
        hold off
        
        
        %f_plot = squeeze(log_f_interp(it, :, :));
        f_plot = squeeze(f_interp.arr(it, :, :));
        f_plot(find(f_plot<0)) = NaN;
        f_plot = log10(f_plot);
        f_plot(isinf(f_plot)) = NaN;
        f_plot(find(f_plot>c_max)) = c_max;
        f_plot(find(f_plot<c_min)) = c_min;
        %f_plot(find(f_plot<-1)) = NaN;

        %f_plot(isnan(f_plot)) = c_min;
        %f_plot = f_plot.*outside.arr;

       % f_plot(find(outside.arr)) = NaN;
        
        contourf(X.arr, Y.arr, f_plot, 100);
        %pcolor(X.arr, Y.arr, f_plot);
        shading flat
        %pcolor(X.arr, Y.arr, f_plot);
        hold on

        if (false)
            pc1 = pcolor(X.arr, Y.arr, f_plot*NaN);
            set(pc1, 'LineWidth', 1, 'LineStyle', ':')
        end
        xlim([x_min x_max]);
        ylim([y_min y_max]);

        set(gca, 'xDir', 'reverse', 'yDir', 'reverse')
        xlabel('X, R_E');
        ylabel('Y, R_E');

        %title(['Normalized PSD, \mu=', num2str(unique(mu.arr(:, :, V_idx, K_idx))), ' MeV/G, K=', num2str(unique(K.arr(:,:,V_idx, K_idx)))])
        %title(['Normalized PSD, \mu=', num2str(target_mu), ' MeV/G, K=', num2str(target_K)])
        %title(['Normalized PSD, \mu=', num2str(unique(mu.arr)), ' MeV/G, K=', num2str(unique(K.arr))])

        caxis([c_min c_max]);
        ax_pos = get(gca, 'Position');
        cl = colorbar('West');
        cl_pos = get(cl, 'Position');
        cl_x_pos = ax_pos(1) + ax_pos(3) + 0.035;%0.015; %0.925
        set(cl, 'Position', [cl_x_pos, cl_pos(2), cl_pos(3), cl_pos(4)]);
        
        %text(min(xlim), (min(ylim) + max(ylim))/2, 'log_{10}(PSD) (c/cm/MeV)^3', 'Rotation', 90, 'VerticalAlignment', 'top', 'HorizontalAlignment', 'center', 'FontWeight', 'bold', 'FontSize', 10);
        text(min(xlim), (min(ylim) + max(ylim))/2, ['log_{10} ', f_interp.units], 'Rotation', 90, 'VerticalAlignment', 'top', 'HorizontalAlignment', 'center', 'FontWeight', 'bold', 'FontSize', 10);

        text(min(xlim), min(ylim), [datestr(f_interp.time(it))], 'VerticalAlignment', 'top', 'HorizontalAlignment', 'right', 'color', 'black')

        % MLT labels
        %text(X.arr(1,1), Y.arr(1,1), num2str(mod(P.arr(1,1)*12/pi+12, 24), '%2.0f'), 'VerticalAlignment', 'middle', 'HorizontalAlignment', 'left')
        %text(X.arr(round(1*(end-1)/4)+1,1), Y.arr(round(1*(end-1)/4)+1,1), num2str(mod(P.arr(round(1*(end-1)/4)+1,1)*12/pi+12, 24), '%2.0f'), 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'center')
        %text(X.arr(round(2*(end-1)/4)+1,1), Y.arr(round(2*(end-1)/4)+1,1), num2str(mod(P.arr(round(2*(end-1)/4)+1,1)*12/pi+12, 24), '%2.0f'), 'VerticalAlignment', 'middle', 'HorizontalAlignment', 'right')
        %text(X.arr(round(3*(end-1)/4)+1,1), Y.arr(round(3*(end-1)/4)+1,1),
        %num2str(mod(P.arr(round(3*(end-1)/4)+1,1)*12/pi+12, 24), '%2.0f'), 'VerticalAlignment', 'top', 'HorizontalAlignment', 'center')    

        plot_earth
                
        plot(Lmp.x, Lmp.y, '-', 'Color', [1 .0 .0], 'LineWidth', 4)
        
        hold off

        %title(['Convection only, ', 'K = ', f_interp.Q2, ' G^{0.5} R_{E},  \mu = ', f_interp.Q1, ' MeV/G '])
        %title(['Convection only, ', f_interp.Q1_text, ', ', f_interp.Q2_text])
        title(figure_title);

        % plasmasphere
        hold on
        %[tmp, Lpp_it] = min(abs(Lpp(:,1) - f_interp.time(it)));
        Lpp_it = max(find(Lpp(:, 1) <= f_interp.time(it)));
        plot(Lpp(Lpp_it,2)*exp(i*linspace(0,2*pi,1000))+[0,0]*[1 i].', ':w')        
        
        %tmp = outside.arr(:,:,1,1);
        %tmp(tmp == -1) = NaN;
        %pcolor(X.arr, Y.arr, tmp);
        %shading flat
        
        
        %%
        if (false)
        subplot(4,1,1);

        Kp = load([input_folder, 'Kp.dat']);

        plot(Kp(:,1), Kp(:,2), 'k');
        axis tight
        ylim([0 9])
        try xlim([f_interp.time(1) f_interp.time(end)]); end;
        ylabel('Kp');
        
        hold on
        plot([f_interp.time(it) f_interp.time(it)], ylim, 'k--');
        
        if (it == 1)
            %datetick('x', 'mm/dd', 'keeplimits', 'keepticks');
            datetick('x', 'mm/dd', 'keeplimits');
            xt = get(gca, 'xticklabel');
        else
            set(gca, 'xticklabel', xt);
        end


        subplot(4,1,2);

        hold on

        names = {};
        plot(DLL_scale(:,1), DLL_scale(:,2), 'g'); names = {names{:}, 'DLL scale'};
        plot(L_UBC_scale(:,1), L_UBC_scale(:,2), 'r');  names = {names{:}, 'Upper boundary scale'};
        %plot(chorus_scale(:,1), chorus_scale(:,2), 'b');
        %plot(Losses_scale(:,1), Losses_scale(:,2), 'b');
        %ylim([-0.1 3.1])
        ylabel('Scaling coefficients');
        axis tight
        %ylim([0 2])
        ylim([0 max(ylim)*1.1])
        try xlim([f_interp.time(1) f_interp.time(end)]); end;
        
        set(gca, 'xticklabel', xt);

                
        legend(names);
        
        hold on
        plot([f_interp.time(it) f_interp.time(it)], ylim, 'k--');
        
        end
        
        
        %save_picture(gcf, ['./Video/PSD_M=', num2str(unique(mu.arr)), '_', num2str(it, '%03.0f')], 'jpg', 'pdf', 'epsc');
        frame = getframe(f1);
        mov = addframe(mov, frame);
    end

    mov = close(mov);

    %save_picture(gcf, ['./Plots/PSD_M=', num2str(unique(mu.arr))], 'jpg', 'pdf', 'epsc');

return

%%

iP = 10;
iR = 14;

figure
pcolor(squeeze(al.arr(iP, iR, :, :))*180/pi, squeeze(en.arr(iP, iR, :, :)), squeeze(en.arr(iP, iR, :, :)*NaN))
set(gca, 'yscale', 'log')
xlim([0 90]);
ylim([1e-2 1e2])



%%


figure

plot(squeeze(R.arr(1,:,end)), squeeze(PSD.arr(:,15,end,:))');











