function y = J_L7(x, x1, y1, x2, y2)
    %%
    % J_L7 exponential interpolation/extrapolation between two points
    %
    % Input:
    %   x - the x-value to get value at
    %   x1,y1 - first data point
    %   x2,y2 - second data point

    % Author: Yuri Shprits
    % Email: shprits@mit.edu
    % Last change: 20014-01-01 by Dmitriy Subbotin
    % The work was supported by:
    %   LANL grant 12-LR-235337, PI Yuri Shprits
    %   NASA grant NNX09AF51G, PI Yuri Shprits
    
    %   x1=0.2;
    %   y1=2.e3;
    %  x2=1.;
    %   y2=7.;
   bcoef = log(y1/y2)/(x2-x1);
   acoef = y2*exp(bcoef*x2);
   y = acoef*exp(-bcoef*x);

end
   
